/********************************************************/
/*   filename: daten.h                                  */
/*                                                      */
/********************************************************/
/* programmed by: Oliver Wagner                         */
/* last change:  (XXX: not updated)                     */
/********************************************************/
#ifndef _DATEN_H
#define _DATEN_H

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

class Datensatz;
enum Daten_Typ {
  Normal, Klassifiziert
};

#include "fehler.h"
#include "vektor.h"
#include "matrix.h"
//#include "regel.h"

#define NAMENLAENGE 20
#endif

#ifndef _DATEN_DATA
#define _DATEN_DATA

class Datensatz
{
  DVektorArray Daten;		/* Die Daten-Vektoren           */
  char **Namen;			/* Bezeichnung der Daten        */
  int OutputDim;		/* Dimension des OutPutputs     */
  BVektor relevant;		/* BOOL fuer zu beruecksicht. Daten */
  IVektor Klassen;		/* die Nummern der Klassen      */
  Daten_Typ Typ;		/* Der Typ halt                 */
  BVektor eindeutig;
  DVektorArray Zugehoerigkeiten;	/* zu den Klassen               */
    public:
    Datensatz (int Dim = 0, int OutDim = 0, int Anzahl = 0);
    Datensatz (const Datensatz & Daraus);
   ~Datensatz ();
  inline int Lese_OutputDim () {
    return (OutputDim);
  };
  inline int Lese_InputDim () {
    return (Daten.Lese_Dim () - OutputDim);
  };
  inline int Lese_DatenDim () {
    return (Daten.Lese_Dim ());
  };
  inline int Lese_Groesse () {
    return (Daten.Lese_Groesse ());
  };
  inline void Setze_OutputDim (int i) {
    OutputDim = i;
  };
  inline void Setze_InputDim (int i) {
    OutputDim = Daten.Lese_Dim () - i;
  };
  inline Daten_Typ & Lese_Daten_Typ () {
    return (Typ);
  };
  inline void Setze_Daten_Typ (Daten_Typ Damit) {
    Typ = Damit;
  };
  inline BVektor & Lese_eindeutig () {
    return (eindeutig);
  };

  inline char *Lese_Name_Pointer (int i) {
    return (Namen[i]);
  };
  inline char **Lese_Name_Pointer () {
    return (Namen);
  };
  void File_speichern (char *Name);
  friend Datensatz File_einlesen (char *Name);

  inline void Setze_Relevant (BVektor & Damit) {
    relevant = Damit;
  };
  inline void Setze_Relevant (int Nummer) {
    relevant.Setze_i (Nummer, TRUE);
  };
  inline void Setze_Unrelevant (int Nummer) {
    relevant.Setze_i (Nummer, TRUE);
  };
  inline char Lese_i_relevant (int i) {
    return ((char) relevant.Lese_i (i));
  };
  inline BVektor & Lese_relevant () {
    return (relevant);
  };
  inline int Lese_relevanteDim () {
    return (relevant.Anzahl_gesetzt ());
  };

  inline DVektorArray & Lese_Daten () {
    return (Daten);
  };
  inline DVektor & Lese_Daten (int i) {
    return (Daten[i]);
  };

  inline DVektor & Lese_Durchschnittsdatum () {
    return (Daten.Lese_Durchschnitt ());
  };

    Datensatz & operator = (Datensatz & Der);
  void operator += (DVektor & Der);
  void operator -= (DVektor & Der);
  inline void Setze_Zugehoerigkeiten (DVektorArray & Damit) {
    Zugehoerigkeiten = Damit;
  };
  inline DVektorArray & Lese_Zugehoerigkeiten () {
    return (Zugehoerigkeiten);
  };
};

Datensatz File_einlesen (char *Name);
#endif
