//**************************************************************
//*   filename: ellipses.h                                     *
//*                                                            *
//**************************************************************
//* programmed by: Thomas Wagner                               *
//* last change:  (XXX: not updated)                           *
//**************************************************************
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>

class Ellipsis_2d;
class Ellipsis_3d;
class Ellipsis;

#ifndef ELLIPSES_H
#define ELLIPSES_H

#include "output.h"

// used for ellipsis-cluster
#define POINTSPERSEGMENT 10	// 1/4 part of ellipsis

typedef struct Point_2d {
  double x, y;
} Point_2d;

typedef struct Point_3d {
  double x, y, z;
} Point_3d;

class Ellipsis
{
  public:
  Ellipsis () {;
  } virtual ~ Ellipsis () {;
  }
  virtual void DrawMe (Output2d_3d * window,
		       Drawable drawable) = NULL;
};

class Ellipsis_2d:
  public Ellipsis
{
  Point_2d *ellipsis;
  double center[2];

    public:
    Ellipsis_2d (DMatrix * form,
		 double centerx, double centery);
    virtual ~ Ellipsis_2d ();
  virtual void DrawMe (Output2d_3d * window,
		       Drawable drawable);
};

class Ellipsis_3d:
  public Ellipsis
{
  Point_3d *ellipsis[3];
  double center[3];

    public:
    Ellipsis_3d (DMatrix * form,
		 double centerx, double centery, double centerz);
    virtual ~ Ellipsis_3d ();
  virtual void DrawMe (Output2d_3d * window,
		       Drawable drawable);
};

#endif
