/********************************************************/
/*   filename: fehler.cc                                */
/*                                                      */
/********************************************************/
/* programmed by: Oliver Wagner                         */
/* last change:  (XXX: not updated)                     */
/********************************************************/

#include <stdio.h>

#include "fehler.h"

static FEHLER Fehlerstatus = KEINFEHLER;

void 
Fehlermeldung (char *Wo, FEHLER Fehler)
{
  Fehlerstatus = Fehler;

  printf ("*\n");
  if (Fehler != KEINFEHLER) {
    printf ("* Error in %s:\n", Wo);
    switch (Fehler) {
    case DATEIOEFFNENFEHLER:
      printf ("* Cannot open file.\n");
      break;
    case DATEIFORMATFEHLER:
      printf ("* Syntaxerror in file.\n");
      break;
    case SPEICHERFEHLER:
      printf ("* Out of memory.\n");
      printf ("* Fatal error - exiting.\n*\n");
      exit (0);
      break;
    case DIMFEHLER:
      printf ("* Dimension mismatch.\n");
      break;
    case KOMPATIBILITAETSFEHLER:
      printf ("* Assinging unequal classes.\n");
      break;
    case INVERTIERFEHLER:
      printf ("* Matrix inversion failed.\n");
      break;
    case KOMPLEXFEHLER:
      printf ("* Unexpected complex result.\n");
    default:
      printf ("* Unknown error (this should not happen).\n");
      break;
    }
  }
  printf ("*\n"); fflush (stdout);
}

FEHLER 
Lese_Fehlerstatus ()
{
  return (Fehlerstatus);
};

void 
Reset_Fehlerstatus ()
{
  Fehlerstatus = KEINFEHLER;
};
