//**************************************************************
//*   filename: mainwindow.h                                   *
//*                                                            *
//**************************************************************
//* programmed by: Thomas Wagner                               *
//* last change:  (XXX: not updated)                           *
//**************************************************************
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xresource.h>

class MainWindow;

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include "window.h"
#include "errorbox.h"
#include "menu.h"
#include "connect.h"
#include "moveicon.h"
#include "selectwindow.h"
#include "saveloadwindow.h"
#include "dialog.h"

enum MAINACTIONS {
  MAIN_NO_ACTION,
  EXIT_ACTION,
  YES_ACTION,
  NO_ACTION,
  MAIN_MAPME_ACTION,
  MAIN_CREATECONNECTION_ACTION,
  MAIN_DESTROYCONNECTION_ACTION,
  MAIN_NEWINPUT_ACTION,
  MAIN_DELETEINPUT_ACTION,
  MAIN_CREATEINPUT_OK,
  MAIN_SAVEINPUT_ACTION,
  MAIN_SAVEINPUT_OK,
  MAIN_CREATECLUSTERSELECTION_ACTION,
  MAIN_CREATECLUSTERING_OK,
  MAIN_DELETECLUSTER_ACTION,
  MAIN_CREATERULE_ACTION,
  MAIN_DELETERULE_ACTION,
  MAIN_SAVERULE_ACTION,
  MAIN_LOADRULE_ACTION,
  MAIN_LOADRULE_OK,
  MAIN_QUIT_ACTION,
  MAIN_QUIT_DIALOG_FINISHED_ACTION,
  MAIN_CREATECLASSIFY_ACTION,
  MAIN_DELETECLASSIFY_ACTION,
  MAIN_SAVECLASSIFY_ACTION,
  MAIN_LOADCLASSIFY_ACTION,
  MAIN_LOADCLASSIFY_OK,
  MAIN_LOADCLUSTER_OKACTION,
  MAIN_LOADCLUSTER_OK
};

// enum for MainWindow->status
enum MAINSTATUS {
  MAINNORMALSTATUS,
  MAINQUITREQUESTSTATUS,
  MAINSTARTCONNECTSTATUS,
  MAINENDCONNECTSTATUS,
  MAINDESTROYCONNECTSTATUS,
  MAINMOVECONNECTSTARTSTATUS,
  MAINMOVECONNECTENDSTATUS,
  MAINLOADINPUTSTATUS,
  MAINSAVEINPUTSTATUS,
  MAINDELETEINPUTSTATUS,
  MAINDELETECLUSTERINGSTATUS,
  MAINNEWCLUSTERINGSTATUS,
  MAINLOADRULESTATUS,
  MAINSAVERULESTATUS,
  MAINDELETERULESTATUS,
  MAINLOADCLASSIFYSTATUS,
  MAINSAVECLASSIFYSTATUS,
  MAINDELETECLASSIFYSTATUS,
  MAINCLASSIFYOPTIONDISPLAYINGSTATUS,
  MAINLOADCLUSTERSTATUS,
  MAINSAVECLUSTERSTATUS,
  MAINCLUSTEROPTIONDISPLAYINGSTATUS,
  MAINRULEOPTIONDISPLAYINGSTATUS,
  MAIN_SAVELOADDISPLAYING_STATUS
};

#define MAIN_TOP_SPACE               17		// used by menu

class MainWindow:
  public BigWindow
{
  Menu *menu;
  MAINSTATUS status;
  SaveLoadWindow *saveloadwindow;
  ErrorBox *errorbox;
  char Done;
  MoveableIconlist *moveableiconlist;
  Connectlist *allconnections;
  Connection *acuteconnection;
    public:

    MainWindow (Display * initdisplay,
		GC initgc,
		XFontStruct * fontstruct,
		int initx, int inity, int initwidth, int initheight,
		char *text);
    virtual ~ MainWindow ();
  virtual void Action (int actionnumber, int value);
  virtual void HandleEvent (XEvent * Event);
  inline void HandleEventqueue ();
  inline void AddnewMoveableIcon (MoveableIcon * NewIcon);
  inline void DelMoveableIcon (MoveableIcon * Icon);
  void printError (char *newtext);
  inline SaveLoadWindow *Getsaveloadwindow () {
    return saveloadwindow;
  } 
  inline void SetStatus (MAINSTATUS newstatus);
  inline MAINSTATUS GetStatus () {
    return status;
  }
  inline Connectlist *GetConnectlist () {
    return allconnections;
  }
  inline Connection *GetAcuteconnection () {
    return acuteconnection;
  }
  inline void SetAcuteconnection (Connection * newcon) {
    acuteconnection = newcon;
  }
};

#endif
