/********************************************************/
/*   filename: norm.cc                                  */
/*                                                      */
/********************************************************/
/* programmed by: Oliver Wagner                         */
/* last change: 22-03-95                                */
/********************************************************/
#include "norm.h"

Norm::Norm ()
{
};

Norm::~Norm ()
{
};

double 
Norm::d (DVektor & X, DVektor & Y)
{
  return (sqrt (d_quadr (X, Y)));
};

double 
Norm::d_quadr (DVektor & X, DVektor & Y)
{
  double Result = 0;
  int i;

  for (i = 0; i < X.Lese_Dim (); i++)
    Result += (X.Lese_i (i) - Y.Lese_i (i)) *
      (X.Lese_i (i) - Y.Lese_i (i));

  return (Result);
};

double 
Norm::d (DMatrix & X, DMatrix & Y)
{
  return (sqrt (d_quadr (X, Y)));
};

double 
Norm::d_quadr (DMatrix & X, DMatrix & Y)
{
  int i, j;
  double Result = 0;

  for (i = 0; i < X.Lese_Dim_m (); i++)
    for (j = 0; j < X.Lese_Dim_n (); j++)
      Result += (X.Lese_i_j (i, j) - Y.Lese_i_j (i, j)) *
	(X.Lese_i_j (i, j) - Y.Lese_i_j (i, j));
  return (Result);
};

/***********************************************************/
A_Norm::A_Norm ()
{
};

A_Norm::A_Norm (const A_Norm & Das)
{
  A = Das.A;
};

A_Norm::~A_Norm ()
{
  A. ~ DMatrix ();
};

double 
A_Norm::d (DMatrix & A, DVektor & X, DVektor & Y)
{
  return (sqrt (d_quadr (A, X, Y)));
};

double 
A_Norm::d_quadr (DMatrix & A, DVektor & X, DVektor & Y)
{
  double Result;
  DVektor Buffer, Differenz;

  Differenz = X - Y;
  Buffer = A * Differenz;
  Result = Differenz * Buffer;

  return (Result);
};

double 
A_Norm::d (DMatrix & A, DMatrix & X, DMatrix & Y)
{
  return (sqrt (d_quadr (A, X, Y)));
};

double 
A_Norm::d_quadr (DMatrix & A, DMatrix & X, DMatrix & Y)
{
  double Result = 0;
  int m, n;

  for (m = 0; m < A.Lese_Dim_m (); m++) {
    for (n = 0; n < A.Lese_Dim_n (); n++)
      Result += A[m][n] * (X[m][n] - Y[m][n]) * (X[m][n] - Y[m][n]);
  }

  return (Result);
};
