/********************************************************/
/*   filename: regel.cc                                 */
/*                                                      */
/********************************************************/
/* programmed by: Oliver Wagner                         */
/* last change: 22-03-95                                */
/********************************************************/
#include "regel.h"

/********************************************************/
/*          Alles zur Klasse Trapez_Parameter           */
/********************************************************/
Trapez_Parameter::Trapez_Parameter ()
{
  /* hier muss noch was rein */

  So = Trapez;
};

Trapez_Parameter::Trapez_Parameter (const Trapez_Parameter & Das)
{
  So = Trapez;
  Daten[0] = Das.Daten[0];
  Daten[1] = Das.Daten[1];
  Daten[2] = Das.Daten[2];
  Daten[3] = Das.Daten[3];
  Steigung[0] = Das.Steigung[0];
  Steigung[1] = Das.Steigung[1];
};

Trapez_Parameter::Trapez_Parameter (const Parameter & Das)
{
  if (Das.So == Trapez) {
    So = Trapez;
    Daten[0] = ((Trapez_Parameter &) Das).Daten[0];
    Daten[1] = ((Trapez_Parameter &) Das).Daten[1];
    Daten[2] = ((Trapez_Parameter &) Das).Daten[2];
    Daten[3] = ((Trapez_Parameter &) Das).Daten[3];
    Steigung[0] = ((Trapez_Parameter &) Das).Steigung[0];
    Steigung[1] = ((Trapez_Parameter &) Das).Steigung[1];
  } else
    Fehlermeldung ("Trapez_Parameter::Trapez_Parameter(const Parameter& Das)", KOMPATIBILITAETSFEHLER);
};

void 
Trapez_Parameter::print ()
{
  printf ("\nTrapez_Parameter: %f 0, %f 1, %f 1, %f 0\n", Daten[0], Daten[1],
	  Daten[2], Daten[3]);
};

void 
Trapez_Parameter::Setze_Parameter (Parameter & Damit)
{
  int i;

  for (i = 0; i < 4; i++)
    Daten[i] = Damit.Lese_xParameter (i);
  if (Daten[0] != Daten[1])
    Steigung[0] = 1 / (Daten[1] - Daten[0]);
  if (Daten[2] != Daten[3])
    Steigung[1] = 1 / (Daten[2] - Daten[3]);
};

void 
Trapez_Parameter::Setze_xParameter (int Index, double Damit)
{
  Daten[Index] = Damit;
  if (Index < 2) {		/* 1 oder 0 */
    if (Daten[0] != Daten[1])
      Steigung[0] = 1 / (Daten[1] - Daten[0]);
  } else {
    if (Daten[2] != Daten[3])
      Steigung[1] = 1 / (Daten[2] - Daten[3]);
  }
};

double 
Trapez_Parameter::Lese_yParameter (int i)
{
  if ((i == 0) || (i == 3))
    return (0);
  else
    return (1);
};


Parameter & Trapez_Parameter::operator = (Parameter & Das) {
  int i;

  if (Das.So == Trapez) {
    for (i = 0; i < 4; i++)
      Daten[i] = Das.Lese_xParameter (i);
    Steigung[0] = ((Trapez_Parameter &) Das).Steigung[0];
    Steigung[1] = ((Trapez_Parameter &) Das).Steigung[1];
  } else
    Fehlermeldung ("Trapez_Parameter::operator=()", KOMPATIBILITAETSFEHLER);
};

char 
Trapez_Parameter::Finde_Parameter (DVektorArray & Daraus,
				   double Z_Grenze)
{
  double ptest[4], f, Fehler, Fehlerbuffer;
  int i, k, Index = 0, Schritt;
  DVektorArray Kurve;

  Kurve = Daraus.Quicksort (0);
  Kurve = Kurve.Mache_Konvex (1, Z_Grenze);

  if (Kurve.Lese_Groesse () == 0)
    return (FALSE);		/* Das ging so nicht */
  /* Initialisierung der Parameter */
  Daten[0] = Kurve.Lese_Min (0);
  Daten[3] = Kurve.Lese_Max (0);
//  Daten[1]=Daten[0]+(Daten[3]-Daten[0])/3;
  //  Daten[2]=Daten[1]+(Daten[3]-Daten[0])/3;
  Daten[1] = Daten[2] = Kurve[Kurve.Lese_MaxNummer (1)][0];

  f = PARAMETER_F_PROZENT * (Daten[3] - Daten[0]);

  /* jetzt alle Parameter nacheinander aendern */
  for (Schritt = 0; Schritt < PARAMETER_SCHRITTE; Schritt++) {
    for (k = 0; k < 4; k++) {
      /* zunaechst die moeglichen anderen Parameter errechnen */
      ptest[0] = Daten[k] - f;
      if (k != 0) {		/* 1, 2 oder 3 */
	if (ptest[0] < Daten[k - 1])
	  ptest[0] = Daten[k - 1];
      } else {
	if (ptest[0] < Kurve.Lese_Min (0))
	  ptest[0] = Kurve.Lese_Min (0);
      }
      ptest[1] = Daten[k];
      ptest[2] = Daten[k] + f;
      if (k != 3) {		/* 0, 1 oder 2 */
	if (ptest[2] > Daten[k + 1])
	  ptest[2] = Daten[k + 1];
      } else {
	if (ptest[3] < Kurve.Lese_Max (0))
	  ptest[3] = Kurve.Lese_Max (0);
      }
      /* Jetzt die moeglichen Parameter ausprobieren */
      for (i = 0, Fehler = MAXDOUBLE; i < 3; i++) {
	Daten[k] = ptest[i];
	Fehlerbuffer = Parameter_Fehler (Kurve);
	if (Fehlerbuffer < Fehler) {
	  Index = i;
	  Fehler = Fehlerbuffer;
	}
      }
      Daten[k] = ptest[Index];
    }
  }

  if (Daten[0] != Daten[1])
    Steigung[0] = 1 / (Daten[1] - Daten[0]);
  if (Daten[2] != Daten[3])
    Steigung[1] = 1 / (Daten[2] - Daten[3]);

  return (TRUE);
};

void 
Trapez_Parameter::Speichern (FILE * File)
{
  fprintf (File, "%lf %lf %lf %lf\n", Daten[0], Daten[1], Daten[2], Daten[3]);
};

double 
Trapez_Parameter::Berechne_Schwerpunkt (double Hoehe, DVektor & x,
					DVektor & y)
{
  double Integral_fx = 0, Integral_f = 0, Result;

  Berechne_Form (Hoehe, x, y);

  /* erstes Segment */
  if (Hoehe != 0) {
    if (x[1] != x[0]) {		/* nicht senkrecht */
      Integral_fx += Steigung[0] * ((pow (x[1], 3) - pow (x[0], 3)) / 3 -
				x[0] * (pow (x[1], 2) - pow (x[0], 2)) / 2);
      Integral_f += Hoehe * (x[1] - x[0]) / 2;
    }
    /* letztes Segment */
    if (x[3] != x[2]) {
      Integral_fx += Steigung[1] * ((pow (x[3], 3) - pow (x[2], 3)) / 3) +
	((Hoehe - x[2] * Steigung[1]) * (pow (x[3], 2) - pow (x[2], 2)) / 2);
      Integral_f += Hoehe * (x[3] - x[2]) / 2;
    }
    /* mittleres Segment */
    Integral_fx += Hoehe * (pow (x[2], 2) - pow (x[1], 2)) / 2;
    Integral_f += (x[2] - x[1]) * Hoehe;

    if (Integral_f == 0) {	/* Falls nur "Ausgabe-Peak" */
      Result = x[0];
    } else {
      Result = Integral_fx / Integral_f;
    }
  } else {
    Result = x[0] + (x[3] - x[0]) / 2;
  }
  return (Result);
};

double 
Trapez_Parameter::Berechne_Hoehe (double Eingabe)
{
  double Result;

  if ((Eingabe >= Daten[0]) && (Eingabe <= Daten[3])) {		/* im Trapez */
    if (Eingabe < Daten[1]) {
      Result = (Eingabe - Daten[0]) / (Daten[1] - Daten[0]);
    } else if (Eingabe > Daten[2]) {
      Result = (Eingabe - Daten[3]) / (Daten[2] - Daten[3]);
    } else
      Result = 1;
  } else
    Result = 0;

  return (Result);
};

void 
Trapez_Parameter::Berechne_Form (double Hoehe, DVektor & x,
				 DVektor & y)
{
  x.Setze_Dim (4);
  y.Setze_Dim (4);

  x[0] = Daten[0];
  x[3] = Daten[3];
  y[0] = y[3] = 0;
  y[1] = y[2] = Hoehe;

  if (Hoehe != 0) {
    /* erstes Segment */
    if (Daten[1] != Daten[0]) {	/* nicht senkrecht */
      x[1] = Daten[0] + Hoehe / Steigung[0];
    } else
      x[1] = Daten[1];
    /* letztes Segment */
    if (Daten[3] != Daten[2]) {
      x[2] = Daten[3] + Hoehe / Steigung[1];
    } else
      x[2] = Daten[3];
    /* mittleres Segment */
  } else {
    x[1] = Daten[0];
    x[2] = Daten[3];
  }
};


double 
Trapez_Parameter::Parameter_Fehler (DVektorArray & Damit)
{
  double Result = 0;
  int i = 0;

  while ((i < Damit.Lese_Groesse ()) && (Damit[i][0] < Daten[0]))
    Result += pow (Damit[i++][1], 2);
  while ((i < Damit.Lese_Groesse ()) && (Damit[i][0] < Daten[1])) {
    Result += pow (Damit[i][1] - (Damit[i][0] - Daten[0]) /
		   (Daten[1] - Daten[0]), 2);
    i++;
  }
  while ((i < Damit.Lese_Groesse ()) && (Damit[i][0] < Daten[2]))
    Result += pow (1 - Damit[i++][1], 2);
  while ((i < Damit.Lese_Groesse ()) && (Damit[i][0] < Daten[3])) {
    Result += pow (Damit.Lese_Vektor (i, 1) - (Damit[i][0] - Daten[2]) /
		   (Daten[3] - Daten[2]), 2);
    i++;
  }
  while (i < Damit.Lese_Groesse ())
    Result += pow (Damit[i++][1], 2);

  return (Result);
};

Trapez_Parameter 
Trapez_einlesen (FILE * File)
return Result;
{
  if (4 != fscanf (File, "%lf %lf %lf %lf", &(Result.Daten[0]), &(Result.Daten[1]),
		   &(Result.Daten[2]), &(Result.Daten[3])))
    Fehlermeldung ("Trapez_Parameter Trapez_einlesen", DATEIFORMATFEHLER);

  if (Lese_Fehlerstatus () == KEINFEHLER) {
    if (Result.Daten[0] != Result.Daten[1])
      Result.Steigung[0] = 1 / (Result.Daten[1] - Result.Daten[0]);
    if (Result.Daten[2] != Result.Daten[3])
      Result.Steigung[1] = 1 / (Result.Daten[2] - Result.Daten[3]);
  }
};
/********************************************************/
/*          Alles zur Klasse Konvex_Parameter           */
/********************************************************/
Konvex_Parameter::Konvex_Parameter ()
{
  /* hier muss noch was rein */

  So = Konvex;
};

Konvex_Parameter::Konvex_Parameter (const Konvex_Parameter & Das)
{
  So = Konvex;
  Daten = ((Konvex_Parameter &) Das).Daten;
};

Konvex_Parameter::Konvex_Parameter (const Parameter & Das)
{
  if (Das.So == Konvex) {
    So = Konvex;
    Daten = ((Konvex_Parameter &) Das).Daten;
  } else
    Fehlermeldung ("Konvex_Parameter::Konvex_Parameter(const Parameter& Das)", KOMPATIBILITAETSFEHLER);
};

void 
Konvex_Parameter::print ()
{
  int i;

  printf ("\nKonvex_Parameter:");

  for (i = 0; i < Daten.Lese_Dim (); i++)
    printf (" %f %f,", Daten[0][i], Daten[1][i]);
  printf ("\n");
};

void 
Konvex_Parameter::Setze_Parameter (Parameter & Damit)
{
  int i;

  for (i = 0; i < Damit.Lese_Parameter_Anzahl (); i++)
    Daten[0][i] = Damit.Lese_xParameter (i);
};

void 
Konvex_Parameter::Setze_xParameter (int Index, double Damit)
{
  Daten[0][Index] = Damit;
};

void 
Konvex_Parameter::Setze_yParameter (int Index, double Damit)
{
  Daten[1][Index] = Damit;
};

Parameter & Konvex_Parameter::operator = (Parameter & Das) {
  if (Das.So == Konvex) {
    Daten = ((Konvex_Parameter &) Das).Daten;
  } else
    Fehlermeldung ("Konvex_Parameter::operator=()", KOMPATIBILITAETSFEHLER);
};

char 
Konvex_Parameter::Finde_Parameter (DVektorArray & Daraus,
				   double Z_Grenze)
{
  int i;

  DVektorArray Buffer;

  Buffer = Daraus.Quicksort (0);
  Buffer = Buffer.Mache_Konvex (1, Z_Grenze);

  if (Buffer.Lese_Groesse () == 0)
    return (FALSE);
  Daten. ~ DVektorArray ();
  Daten.DVektorArray (Buffer.Lese_Groesse (), 2, NULL);

  for (i = 0; i < Buffer.Lese_Groesse (); i++) {
    Daten[0][i] = Buffer[i][0];
    Daten[1][i] = Buffer[i][1];
  }
  return (TRUE);
};

void 
Konvex_Parameter::Speichern (FILE * File)
{
  int i;

  fprintf (File, "%d ", Daten.Lese_Dim ());
  for (i = 0; i < Daten.Lese_Dim (); i++)
    fprintf (File, "%lf %lf ", Daten[0][i], Daten[1][i]);
  fprintf (File, "\n");
};

double 
Konvex_Parameter::Berechne_Schwerpunkt (double Hoehe, DVektor & x,
					DVektor & y)
{
  int SegmentNr;
  double Integral_fx = 0, Integral_f = 0, Result, Steigung;

  Berechne_Form (Hoehe, x, y);

  if ((Hoehe == 0) || (x.Lese_Dim () < 2)) {
    if (x.Lese_Dim () < 1)	/* ganz ganz selten */
      Result = x[0];
    else
      Result = (x[x.Lese_Dim () - 1] - x[0]) / 2;
  } else {
    for (SegmentNr = 0; SegmentNr < (x.Lese_Dim () - 1); SegmentNr++) {
      if (x[SegmentNr + 1] != x[SegmentNr]) {
	Steigung = (y[SegmentNr + 1] - y[SegmentNr]) /
	  (x[SegmentNr + 1] - x[SegmentNr]);
	Integral_fx += Steigung * ((pow (x[SegmentNr + 1], 3) - pow (x[SegmentNr], 3)) / 3) +
	  ((y[SegmentNr] - x[SegmentNr] * Steigung) * (pow (x[SegmentNr + 1], 2) - pow (x[SegmentNr], 2)) / 2);
	// (y2-y1)(x2-x1)/2 + y1(x2-x1) =
	// (x2-x1)(y2+y1)/2
	Integral_f += (y[SegmentNr] + y[SegmentNr + 1]) *
	  (x[SegmentNr + 1] - x[SegmentNr]) / 2;
      }
    }
    if (Integral_f == 0) {	/* Falls nur "Ausgabe-Peak" */
      Result = Daten[0][0];
    } else {
      Result = Integral_fx / Integral_f;
    }
  }

  return (Result);
};

double 
Konvex_Parameter::Berechne_Hoehe (double Eingabe)
{
  double Result;
  int Groesse = Daten.Lese_Dim (), i;

  if ((Eingabe >= Daten[0][0]) && (Eingabe <= Daten[0][Groesse - 1])) {		/* jetzt den Bereich suchen, in dem Eingabe liegt */
    for (i = 0; i < Groesse - 1; i++) {
      if ((Eingabe >= Daten[0][i]) && (Eingabe <= Daten[0][i + 1]))
	break;
    }

    if (Daten[0][i] != Daten[0][i + 1]) {
      if (Daten[1][i] != Daten[1][i + 1])
	Result = Daten[1][i] + (Daten[1][i + 1] - Daten[1][i]) *
	  (Eingabe - Daten[0][i]) / (Daten[0][i + 1] - Daten[0][i]);
      else
	Result = Daten[1][i];
    } else {
      if (Daten[1][i + 1] > Daten[1][i])
	Result = Daten[1][i + 1];
      else
	Result = Daten[1][i];
    }
    return (Result);
  } else
    return (0);
};

void 
Konvex_Parameter::Berechne_Form (double Hoehe, DVektor & x,
				 DVektor & y)
{
  DVektor xtemp (Daten.Lese_Dim () + 1, 0, NULL), ytemp (Daten.Lese_Dim () + 1, 0, NULL);
  int i, soviel = 0;

  /* Suchen, bis oberhalb Hoehe */
  for (i = 0; i < Daten.Lese_Dim (); i++) {
    soviel++;
    if (Daten[1][i] < Hoehe) {
      xtemp[i] = Daten[0][i];
      ytemp[i] = Daten[1][i];
    } else {
      ytemp[i] = Hoehe;
      if (i == 0) {		/* gleich der erste oberhalb */
	xtemp[0] = Daten[0][0];
      }
      /* sonst den Punkt erst noch berechnen */ 
      else {
	/* Schnittpunkt bestimmen */
	xtemp[i] = Daten[0][i - 1] + (Daten[0][i] - Daten[0][i - 1]) *
	  (Hoehe - Daten[1][i - 1]) / (Daten[1][i] - Daten[1][i - 1]);
      }
      i++;
      break;
    }
  }

  /* jetzt oberhalb bis zum Schnitt suchen */
  for ( /* i bleibt */ ; i < Daten.Lese_Dim (); i++) {
    if (Daten[1][i] < Hoehe) {	/* wieder drunter */
      xtemp[soviel] = Daten[0][i - 1] + (Daten[0][i] - Daten[0][i - 1]) *
	(Hoehe - Daten[1][i - 1]) / (Daten[1][i] - Daten[1][i - 1]);
      ytemp[soviel++] = Hoehe;
      xtemp[soviel] = Daten[0][i];
      ytemp[soviel++] = Daten[1][i];
      i++;
      break;
    }
  }

  /* jetzt der Rest */
  if ((i == Daten.Lese_Dim ()) && (Hoehe <= Daten[1][i - 1])) {		/* keiner mehr unterhalb */
    xtemp[soviel] = Daten[0][i - 1];
    ytemp[soviel++] = Hoehe;
  } else {
    /* den Rest uebernehmen */
    for ( /* i bleibt */ ; i < Daten.Lese_Dim (); i++) {
      xtemp[soviel] = Daten[0][i];
      ytemp[soviel++] = Daten[1][i];
    }
  }
  /* jetzt noch uebergeben */
  x = xtemp.Projiziere (0, soviel - 1);
  y = ytemp.Projiziere (0, soviel - 1);
};

Konvex_Parameter 
Konvex_einlesen (FILE * File)
return Result ();
{
  int i, Anzahl;

  if (!(fscanf (File, "%d", &Anzahl))) {
    Fehlermeldung ("Konvex_Parameter Konvex_einlesen", DATEIFORMATFEHLER);
  } else {
    Result.Daten.DVektorArray (Anzahl, 2, NULL);
    for (i = 0; i < Anzahl; i++) {
      if (2 != fscanf (File, "%lf %lf",
		       &(Result.Daten[0][i]), &(Result.Daten[1][i]))) {
	Fehlermeldung ("Konvex_Parameter Konvex_einlesen", DATEIFORMATFEHLER);
	Result. ~ Konvex_Parameter ();
	break;
      }
    }
  }
};

/***********************************************************/
/*              Die Oberklasse der Regeln                  */
/***********************************************************/
Dummy_Regel::Dummy_Regel (int xDimension = 0, int yDimension = 0,
	     Parameter_Typ PT = Trapez)
{
  int i;

  xDim = xDimension;
  yDim = yDimension;

  if (xDim + yDim != 0) {
    if ((Namen = (char **) malloc (sizeof (char *) * (xDim + yDim))) == NULL)
        Fehlermeldung ("Dummy_Regel::Dummy_Regel", SPEICHERFEHLER);
    for (i = 0; i < xDim + yDim; i++) {
      if ((Namen[i] = (char *) malloc (sizeof (char) * NAMENLAENGE)) == NULL)
	  Fehlermeldung ("Dummy_Regel::Dummy_Regel", SPEICHERFEHLER);
    }
  }
  if ((xDim != 0) || (yDim != 0)) {
    if ((Daten = (Parameter **) malloc (sizeof (Parameter *) * (xDim + yDim))) == NULL)
      Fehlermeldung ("Dummy_Regel::Dummy_Regel", SPEICHERFEHLER);
    /* Auffuellen */
    switch (PT) {
    case Trapez:
      for (i = 0; i < xDim + yDim; i++)
	Daten[i] = new Trapez_Parameter;
      break;
    case Konvex:
      for (i = 0; i < xDim + yDim; i++)
	Daten[i] = new Konvex_Parameter;
      break;
    default:
      break;
    }
  } else {
    Daten = NULL;
    Namen = NULL;
  }
};

Dummy_Regel::Dummy_Regel (const Dummy_Regel & Das)
{
  int i;

  xDim = Das.xDim;
  yDim = Das.yDim;

  if ((xDim + yDim) != 0) {
    if ((Namen = (char **) malloc (sizeof (char *) * (xDim + yDim))) == NULL)
        Fehlermeldung ("Dummy_Regel::Dummy_Regel(const Dummy_Regel& Das)", SPEICHERFEHLER);
    for (i = 0; i < xDim + yDim; i++) {
      if ((Namen[i] = (char *) malloc (sizeof (char) * NAMENLAENGE)) == NULL)
	  Fehlermeldung ("Dummy_Regel::Dummy_Regel(const Dummy_Regel& Das)", SPEICHERFEHLER);
      strcpy (Namen[i], Das.Namen[i]);
    }
    if ((Daten = (Parameter **) malloc (sizeof (Parameter *) * (xDim + yDim))) == NULL)
      Fehlermeldung ("Dummy_Regel::Dummy_Regel(const Dummy_Regel& Das)", SPEICHERFEHLER);
  } else {
    Daten = NULL;
    Namen = NULL;
  }

  for (i = 0; i < xDim + yDim; i++) {
    if (Das.Daten[i] == NULL)
      Daten[i] = NULL;
    else {
      switch (Das.Daten[i]->Lese_Parameter_Typ ()) {
      case Trapez:
	Daten[i] = new Trapez_Parameter (*(Das.Daten[i]));
	break;
      case Konvex:
	Daten[i] = new Konvex_Parameter (*(Das.Daten[i]));
      default:
	break;
      }
    }
  }
  Nummer = Das.Nummer;
};

Dummy_Regel::~Dummy_Regel ()
{
  int i;

  if ((xDim != 0) || (yDim != 0)) {
    for (i = 0; i < xDim + yDim; i++) {
      delete Daten[i];
      free (Namen[i]);
    }
    free (Namen);
    free (Daten);
    Namen = NULL;
    Daten = NULL;
    xDim = yDim = 0;
  }
};

void 
Dummy_Regel::Speichern (FILE * File)
{
  int i;

  if (this->Lese_Typ () == Typ_Klasse)
    fprintf (File, "%d\n", Lese_Nummer ());
  for (i = 0; i < (xDim + yDim); i++) {
    fprintf (File, "%s ", Namen[i]);
    switch (Daten[i]->Lese_Parameter_Typ ()) {
    case Trapez:
      fprintf (File, "%s ", "trapezoid");
      break;
    case Konvex:
      fprintf (File, "%s ", "convex");
      break;
    }
    Daten[i]->Speichern (File);
  }

  fprintf (File, "\n");
};

void 
Dummy_Regel::Setze_Parameter (int Index, Parameter & Damit)
{
  int i = 0;

  if (Daten[i]->Lese_Parameter_Typ () != Damit.Lese_Parameter_Typ ()) {
    delete Daten[i];
    switch (Damit.Lese_Parameter_Typ ()) {
    case Trapez:
      Daten[i] = new Trapez_Parameter (Damit);
      break;
    case Konvex:
      Daten[i] = new Konvex_Parameter (Damit);
      break;
    default:
      break;
    }
  } else {
    *(Daten[i]) = Damit;
  }
};

Dummy_Regel & Dummy_Regel::operator = (const Dummy_Regel & Das) {
  int i;
  char **cBuffer;
  Parameter **PBuffer;

  if ((xDim + yDim) != (Das.xDim + Das.yDim)) {		/* Speicher groessenmaeszig anpassen */
    if ((Das.xDim + Das.yDim) != 0) {
      cBuffer = Namen;
      PBuffer = Daten;
      if ((Namen = (char **) malloc (sizeof (char *) * (Das.xDim + Das.yDim))) == NULL)
	  Fehlermeldung ("Dummy_Regel::operator=(Dummy_Regel& Das)", SPEICHERFEHLER);
      if ((Daten = (Parameter **) malloc (sizeof (Parameter *) * (Das.xDim + Das.yDim))) == NULL)
	Fehlermeldung ("Dummy_Regel::operator=(Dummy_Regel& Das)", SPEICHERFEHLER);

      for (i = 0; (i < (xDim + yDim)) && (i < (Das.xDim + Das.yDim)); i++) {	/* noch zu verwendene Speicher-Belegung */
	Namen[i] = cBuffer[i];
	Daten[i] = PBuffer[i];
      }
      for (; i < (xDim + yDim); i++) {	/*ueberfluessiges loeschen */
	free (cBuffer[i]);
	delete PBuffer;
      }
      for (; i < (Das.xDim + Das.yDim); i++) {
	if ((Namen[i] = (char *) malloc (sizeof (char) * NAMENLAENGE)) == NULL)
	    Fehlermeldung ("Dummy_Regel::operator=(Dummy_Regel& Das)", SPEICHERFEHLER);
	switch (Das.Daten[i]->Lese_Parameter_Typ ()) {
	case Trapez:
	  Daten[i] = new Trapez_Parameter (*(Das.Daten[i]));
	  break;
	case Konvex:
	  Daten[i] = new Konvex_Parameter (*(Das.Daten[i]));
	  break;
	}
      }
      free (cBuffer);
      free (PBuffer);
    } else {
      Daten = NULL;
      Namen = NULL;
    }
  }
  for (i = 0; i < (Das.xDim + Das.yDim); i++) {
    strcpy (Namen[i], Das.Namen[i]);
  }

  for (i = 0; i < (xDim + yDim); i++) {		/* nur die alten Dimensionen aendern, die anderen sind schon neu */
#if 0
    if (Daten[i].Lese_Parameter_Typ () != Das.Daten[i].Lese_Parameter_Typ ())
#else
    if (Daten[i]->Lese_Parameter_Typ () != Das.Daten[i]->Lese_Parameter_Typ ())
#endif
    {
      delete Daten[i];
      switch (Das.Daten[i]->Lese_Parameter_Typ ()) {
      case Trapez:
	Daten[i] = new Trapez_Parameter (*(Das.Daten[i]));
	break;
      case Konvex:
	Daten[i] = new Konvex_Parameter (*(Das.Daten[i]));
      default:
	break;
      }
    } else {
      (*(Daten[i])) = (*(Das.Daten[i]));
    }
  }

  xDim = Das.xDim;
  yDim = Das.yDim;
  Nummer = Das.Nummer;
};

void 
Dummy_Regel::File_einlesen (FILE * File, int x, int y)
{
  int i, j;
  char Buffer[NAMENLAENGE];

  xDim = x;
  yDim = y;
  if (x + y != 0) {
    if ((Namen = (char **) malloc (sizeof (char *) * (x + y))) == NULL)
        Fehlermeldung ("Dummy_Regel::File_einlesen(FILE* File,int x, int y)", SPEICHERFEHLER);
    for (i = 0; i < x + y; i++) {
      if ((Namen[i] = (char *) malloc (sizeof (char) * NAMENLAENGE)) == NULL)
	  Fehlermeldung ("Dummy_Regel::File_einlesen(FILE* File,int x, int y)", SPEICHERFEHLER);
    }
    if ((Daten = (Parameter **) malloc (sizeof (Parameter *) * (x + y))) == NULL)
      Fehlermeldung ("Dummy_Regel::File_einlesen(FILE* File,int x, int y)", SPEICHERFEHLER);

    for (i = 0; i < x + y; i++) {
      /* Auffuellen */
      if (2 != fscanf (File, "%20s %20s", Namen[i], Buffer)) {
	Fehlermeldung ("Dummy_Regel::File_einlesen", DATEIFORMATFEHLER);
	break;
      }
      if (Lese_Fehlerstatus () == KEINFEHLER) {
	if (!(strcmp (Buffer, "trapezoid"))) {
	  Daten[i] = new Trapez_Parameter (Trapez_einlesen (File));
	} else if (!(strcmp (Buffer, "convex"))) {
	  Daten[i] = new Konvex_Parameter (Konvex_einlesen (File));
	} else {
	  Fehlermeldung ("Dummy_Regel::File_einlesen", DATEIFORMATFEHLER);
	}
      }
      if (Lese_Fehlerstatus () != KEINFEHLER) {
	for (j = 0; j < i; j++)
	  delete (Daten[j]);
	for (i++; i < x + y; i++)	/* auffuellen */
	  Daten[i] = NULL;
	xDim = 0;
	yDim = 0;
	free (Daten);
	for (i = 0; i < x + y; i++)
	  free (Namen[i]);
	free (Namen);
	break;
      }
    }
  } else {
    Daten = NULL;
    Namen = NULL;
  }
};

/********************************************************/
/*              Alles zur Klasse Regel                  */
/********************************************************/
Regel::Regel (int xDimension, int yDimension, Parameter_Typ PT = Trapez)
{
  ((Dummy_Regel *) (this))->Dummy_Regel (xDimension, yDimension, PT);
};

Regel::Regel (const Regel & Das)
{
  (*((Dummy_Regel *) this)) = ((const Dummy_Regel &) Das);
};

Regel::~Regel ()
{
};

void 
Regel::print ()
{
  int i;

  printf ("Falls ");
  for (i = 0; i < xDim; i++) {
    printf ("%s", Namen[i]);
    Daten[i]->print ();
    if (i + 1 != xDim)
      printf ("und   ");
  }

  printf ("dann ");
  for (i = 0; i < yDim; i++) {
    printf ("%s", Namen[i + xDim]);
    Daten[i + xDim]->print ();
    if (i + 1 != xDim)
      printf ("und  ");
  }
}

void 
Regel::Setze_Dimensionen (int In, int Out)
{
  int i;
  Parameter_Typ PT = Trapez;

  if (xDim + yDim != 0)
    PT = Daten[0]->Lese_Parameter_Typ ();

  if ((In + Out) != (xDim + yDim)) {
    for (i = 0; i < xDim + yDim; i++) {
      free (Namen[i]);
      delete Daten[i];
    }
    free (Namen);
    free (Daten);
    Namen = NULL;
    Daten = NULL;
    if ((In + Out) != 0) {
      if ((Namen = (char **) malloc (sizeof (char *) * (In + Out))) == NULL)
	  Fehlermeldung ("Regel::Setze_Dimensionen", SPEICHERFEHLER);
      for (i = 0; i < xDim + yDim; i++) {
	if ((Namen[i] = (char *) malloc (sizeof (char) * NAMENLAENGE)) == NULL)
	    Fehlermeldung ("Regel::Setze_Dimensionen", SPEICHERFEHLER);
      }
      if ((Daten = (Parameter **) malloc (sizeof (Parameter *) * (In + Out))) == NULL)
	Fehlermeldung ("Regel::Setze_Dimensionen", SPEICHERFEHLER);
      switch (PT) {
      case Trapez:
	for (i = 0; i < In + Out; i++)
	  Daten[i] = new Trapez_Parameter ();
	break;
      case Konvex:
	for (i = 0; i < In + Out; i++)
	  Daten[i] = new Konvex_Parameter ();
	break;
      default:
	break;
      }
    } else
      Daten = NULL;
  }
  xDim = In;
  yDim = Out;
};

void 
Regel::Setze_xDimension (int i)
{
  yDim = yDim + xDim - i;
  xDim = i;
};

void 
Regel::Setze_yDimension (int i)
{
  xDim = xDim + yDim - i;
  yDim = i;
};

void 
Regel::Berechne (DVektor & Eingabe, Regel_Ausgabe & Ausgabe)
{
  int i;

  Ausgabe.Setze_Dim (xDim, yDim);
  Ausgabe.Uebereinstimmung = 1;
  /* zunaechst die Hoehe berechnen */
  for (i = 0; i < xDim; i++) {
    Ausgabe.InputHoehen[i] = Daten[i]->Berechne_Hoehe (Eingabe[i]);
    if (Ausgabe.InputHoehen[i] < Ausgabe.Uebereinstimmung)
      Ausgabe.Uebereinstimmung = Ausgabe.InputHoehen[i];
  }

  /* Jetzt Schwerpunkt bestimmen */
  for (i = xDim; i < xDim + yDim; i++) {	/* alle Ausgaben */
    Ausgabe.Ergebnisse[i - xDim] =
      Daten[i]->Berechne_Schwerpunkt (Ausgabe.Uebereinstimmung,
				      Ausgabe.X_OutputKurve[i - xDim],
				      Ausgabe.Y_OutputKurve[i - xDim]);
  }
};

void 
Regel::Berechne (DVektor & Eingabe, BVektor & Diese_Eingaben,
		 BVektor & Diese_Ausgaben, Regel_Ausgabe & Ausgabe)
{
  int i;

  /* zunaechst die Hoehe berechnen */
  Ausgabe.Setze_Dim (xDim, yDim);
  if (Diese_Eingaben.Anzahl_gesetzt () != 0) {
    Ausgabe.Uebereinstimmung = 1;
    for (i = 0; i < xDim; i++) {
      if (Diese_Eingaben[i]) {
	Ausgabe.InputHoehen[i] = Daten[i]->Berechne_Hoehe (Eingabe[i]);
	if (Ausgabe.InputHoehen[i] < Ausgabe.Uebereinstimmung)
	  Ausgabe.Uebereinstimmung = Ausgabe.InputHoehen[i];
      } else
	Ausgabe.InputHoehen[i] = 0;
    }
  } else
    Ausgabe.Uebereinstimmung = 0;

  /* Jetzt Schwerpunkt bestimmen */
  for (i = xDim; i < xDim + yDim; i++) {	/* alle Ausgaben */
    if (Diese_Ausgaben[i - xDim]) {
      Ausgabe.Ergebnisse[i - xDim] =
	Daten[i]->Berechne_Schwerpunkt (Ausgabe.Uebereinstimmung,
					Ausgabe.X_OutputKurve[i - xDim],
					Ausgabe.Y_OutputKurve[i - xDim]);
    } else {
      Ausgabe.Ergebnisse[i - xDim] = 0;
      Ausgabe.X_OutputKurve[i - xDim]. ~ DVektor ();
      Ausgabe.Y_OutputKurve[i - xDim]. ~ DVektor ();
    }
  }
};

Regel & Regel::operator = (Regel & Das) {
  (*((Dummy_Regel *) this)) = ((Dummy_Regel &) Das);
};

Regel 
Regel_einlesen (FILE * File, int x, int y)
  return Result (0, 0, Trapez /* <- ist aber egal */ );
{
  Result.File_einlesen (File, x, y);
};
/********************************************************/
/*              Alles zur Klasse Regelbasis             */
/********************************************************/
Regelbasis::Regelbasis (int Regelanzahl, int xDimension, int yDimension)
{
  int i;

  Anzahl = Regelanzahl;
  xDim = xDimension;
  yDim = yDimension;

  if (Anzahl != 0) {
    if ((Regeln = (Regel **) malloc (sizeof (Regel *) * Anzahl)) == NULL)
      Fehlermeldung ("Regelbasis::Regelbasis", SPEICHERFEHLER);
    for (i = 0; i < Anzahl; i++)
      Regeln[i] = new Regel (xDimension, yDimension);
  } else
    Regeln = NULL;
};

Regelbasis::~Regelbasis ()
{
  int i;

  if (Anzahl != 0) {
    for (i = 0; i < Anzahl; i++)
      delete Regeln[i];
    free (Regeln);
    xDim = yDim = Anzahl = 0;
    Regeln = NULL;
  }
};

void 
Regelbasis::print ()
{
  int i;

  for (i = 0; i < Anzahl; i++)
    Regeln[i]->print ();
};

void 
Regelbasis::Setze_xDimension (int i)
{
  int j;

  xDim = i;
  for (j = 0; j < Anzahl; j++)
    Regeln[j]->Setze_xDimension (i);
};

void 
Regelbasis::Setze_yDimension (int i)
{
  int j;

  yDim = i;
  for (j = 0; j < Anzahl; j++)
    Regeln[j]->Setze_yDimension (i);
};

void 
Regelbasis::Setze_Dimensionen (int In, int Out)
{
  int i;

  xDim = In;
  yDim = Out;
  for (i = 0; i < Anzahl; i++)
#if 0
    Regeln[i].Setze_Dimensionen (In, Out);
#else
    Regeln[i]->Setze_Dimensionen (In, Out);
#endif
}

void 
Regelbasis::Setze_Regelanzahl (int Damit)
{
  int i;
  Regel **Buffer;

  if (Anzahl != Damit) {
    if (Damit != 0) {
      Buffer = Regeln;
      if ((Regeln = (Regel **) malloc (sizeof (Regel *) * Damit)) == NULL)
	Fehlermeldung ("Regelbasis::Setze_Regelanzahl()", SPEICHERFEHLER);
      for (i = 0; (i < Anzahl) && (i < Damit); i++)
	Regeln[i] = Buffer[i];	/* alte uebernehmen */
      for (; i < Anzahl; i++)
	delete Buffer[i];	/* ueberfluessige */
      for (; i < Damit; i++)
	Regeln[i] = new Regel (xDim, yDim);	/* brauche mehr */
      free (Buffer);
    } else {
      for (i = 0; i < Anzahl; i++)
	delete Regeln[i];
      free (Regeln);
      Regeln = NULL;
    }
    Anzahl = Damit;
  }
};

void 
Regelbasis::Speichern (char *Name)
{
  FILE *File;
  int i;

  if ((File = fopen (Name, "w")) == NULL) {
    Fehlermeldung ("Regelbasis::Speichern(char *Name)", DATEIOEFFNENFEHLER);
  } else {
    fprintf (File, "rules\n");
    fprintf (File, "%d %d %d\n", Anzahl, xDim, yDim);

    for (i = 0; i < Anzahl; i++)
      Regeln[i]->Speichern (File);
    fclose (File);
  }
};

void 
Regelbasis::Berechne (DVektor & Eingabe,
		      Regelbasis_Ausgabe & Ausgabe)
{
  int DimNr, RegelNr;
  double GesammtHoehe = 0;

  Ausgabe.Setze_Dim (xDim, yDim);
  Ausgabe.Setze_Groesse (Anzahl);
  Ausgabe.Ergebnisse.NullVektor ();

  if (yDim != 0) {
    for (RegelNr = 0; RegelNr < Anzahl; RegelNr++) {
      /* Regeln auswerten */
#if 0
      Regeln[RegelNr].Berechne (Eingabe, *(Ausgabe.Ausgaben[RegelNr]));
#else
      Regeln[RegelNr]->Berechne (Eingabe, *(Ausgabe.Ausgaben[RegelNr]));
#endif
      GesammtHoehe += Ausgabe.Ausgaben[RegelNr]->Lese_Uebereinstimmung ();

      for (DimNr = 0; DimNr < yDim; DimNr++) {
	Ausgabe.Ergebnisse[DimNr] +=
	  Ausgabe.Ausgaben[RegelNr]->Lese_Ergebnisse ()[DimNr] *
	  Ausgabe.Ausgaben[RegelNr]->Lese_Uebereinstimmung ();
      }
    }
    /* Gewichte herausdividieren */
    if (GesammtHoehe != 0)
      for (DimNr = 0; DimNr < yDim; DimNr++)
	Ausgabe.Ergebnisse[DimNr] /= GesammtHoehe;
    else
      for (DimNr = 0; DimNr < yDim; DimNr++)
	Ausgabe.Ergebnisse[DimNr] = 0;
  }
};

void 
Regelbasis::Berechne (DVektor & Eingabe, BVektor & Diese_Regeln,
		      BVektor & Diese_Eingaben, BVektor & Diese_Ausgaben,
		      Regelbasis_Ausgabe & Ausgabe)
{
  int DimNr, RegelNr;
  double GesammtHoehe = 0;

  Ausgabe.Setze_Dim (xDim, yDim);
  Ausgabe.Setze_Groesse (Anzahl);
  Ausgabe.Ergebnisse.NullVektor ();

  if (yDim != 0) {
    for (RegelNr = 0; RegelNr < Anzahl; RegelNr++) {
      /* Regeln auswerten */
      if (Diese_Regeln[RegelNr]) {
#if 0
	Regeln[RegelNr].Berechne (Eingabe, Diese_Eingaben,
			      Diese_Ausgaben, *(Ausgabe.Ausgaben[RegelNr]));
#else
	Regeln[RegelNr]->Berechne (Eingabe, Diese_Eingaben,
			      Diese_Ausgaben, *(Ausgabe.Ausgaben[RegelNr]));
#endif
	GesammtHoehe += Ausgabe.Ausgaben[RegelNr]->Lese_Uebereinstimmung ();

	for (DimNr = 0; DimNr < yDim; DimNr++) {
	  if (Diese_Ausgaben[DimNr])
	    Ausgabe.Ergebnisse[DimNr] +=
	      Ausgabe.Ausgaben[RegelNr]->Lese_Ergebnisse ()[DimNr] *
	      Ausgabe.Ausgaben[RegelNr]->Lese_Uebereinstimmung ();
	}
      } else {			/* Ausgaben loeschen */
	Ausgabe.Ausgaben[RegelNr]-> ~ Regel_Ausgabe ();
      }
    }
    /* Gewichte herausdividieren */
    if (GesammtHoehe != 0)
      for (DimNr = 0; DimNr < yDim; DimNr++)
	Ausgabe.Ergebnisse[DimNr] /= GesammtHoehe;
    else
      for (DimNr = 0; DimNr < yDim; DimNr++)
	Ausgabe.Ergebnisse[DimNr] = 0;
  }
};

Regelbasis & Regelbasis::operator = (const Regelbasis & Das) {
  int i;

  if (Das.Anzahl != Anzahl) {
#if 0
    this. ~ Regelbasis ();
#else
    this-> ~ Regelbasis ();
#endif
    Anzahl = Das.Anzahl;
    if (Anzahl != 0) {
      if ((Regeln = (Regel **) malloc (sizeof (Regel *) * Anzahl)) == NULL)
	Fehlermeldung ("Regelbasis::operator=(...)", SPEICHERFEHLER);
      for (i = 0; i < Anzahl; i++)
	Regeln[i] = new Regel (*(Das.Regeln[i]));
    } else
      Regeln = NULL;
  } else {
    for (i = 0; i < Anzahl; i++)
      *(Regeln[i]) = *(Das.Regeln[i]);
  }
  xDim = Das.xDim;
  yDim = Das.yDim;
};

void 
Regelbasis::operator+= (Regel & Diese)
{
  Regel **Buffer;
  int i;

  Buffer = Regeln;

  xDim = Diese.Lese_xDimension ();
  yDim = Diese.Lese_yDimension ();	/* nur zur Sicherheit */
  if ((Regeln = (Regel **) malloc (sizeof (Regel *) * (Anzahl + 1))) == NULL)
    Fehlermeldung ("Regelbasis::Einfuegen_Regel", SPEICHERFEHLER);

  for (i = 0; i < Anzahl; i++)
    Regeln[i] = Buffer[i];


  Regeln[Anzahl] = new Regel (Diese);

  free (Buffer);
  Anzahl++;
};

void 
Regelbasis::operator+= (Regelbasis & Diese)
{
  Regel **Buffer;
  int i, j = 0;

  Buffer = Regeln;

  xDim = Diese.xDim;
  yDim = Diese.yDim;		/* nur zur Sicherheit */
  if (Anzahl + Diese.Anzahl != 0) {
    if ((Regeln = (Regel **) malloc (sizeof (Regel *) * (Anzahl + Diese.Anzahl))) == NULL)
      Fehlermeldung ("Regelbasis::Einfuegen_Regel", SPEICHERFEHLER);

    for (i = 0; i < Anzahl; i++)
      Regeln[i] = Buffer[i];
    for (i = Anzahl; i < Anzahl + Diese.Anzahl; i++) {
      Regeln[i] = new Regel (*(Diese.Regeln[j++]));
    }

    free (Buffer);
    Anzahl += Diese.Anzahl;
  }
};

Regelbasis 
Regelbasis_einlesen (char *Name)
  return Result (0, 0, 0);
{
  int i;
  FILE *File;
  char Buffer[20];

  if ((File = fopen (Name, "r")) == NULL) {
    Fehlermeldung ("Regelbasis_einlesen(char *Name)", DATEIOEFFNENFEHLER);
    return (Result);
  }
  if (!(fscanf (File, "%18s", Buffer))) {
    Fehlermeldung ("Regelbasis_einlesen(char *Name)", DATEIFORMATFEHLER);
    return (Result);
  }
  if (strcmp (Buffer, "rules")) {
    Fehlermeldung ("Regelbasis_einlesen(char *Name)", DATEIFORMATFEHLER);
    return (Result);
  }
  if (3 != fscanf (File, "%d %d %d", &Result.Anzahl, &Result.xDim, &Result.yDim)) {
    Fehlermeldung ("Regelbasis_einlesen(char *Name)", DATEIFORMATFEHLER);
    return (Result);
  }
  if ((Result.Regeln = (Regel **) malloc (sizeof (Regel *) * Result.Anzahl)) == NULL)
    Fehlermeldung ("Regelbasis_einlesen(char *Name)", SPEICHERFEHLER);
  for (i = 0; i < Result.Anzahl; i++) {
    Result.Regeln[i] = new Regel (Regel_einlesen (File, Result.xDim, Result.yDim));
    if (Lese_Fehlerstatus () != KEINFEHLER) {
      i++;
      for (; i < Result.Anzahl; i++)
	Result.Regeln[i] = NULL;
      Result. ~ Regelbasis ();
      break;
    }
  }
};
/********************************************************/
/*              Alle anderen Funktionen                 */
/********************************************************/
Regelbasis 
Ermittle_Regeln (Clustering & Cluster,
		 double Z_Grenze,
		 Datensatz & Daten,
		 int Input_Dim,
		 BVektor & relevante_Dims,
		 Parameter_Typ PT)
  return Result (0, 0, 0);
{
  int i;
  Regelbasis Buffer;

  for (i = 0; i < Cluster.Lese_Zugehoerigkeit ().Lese_Dim_m (); i++) {
    Buffer = Ermittle_Regeln (Cluster, Z_Grenze, Daten,
			      Input_Dim, relevante_Dims, PT, i);
    if (Buffer.Lese_Dimension () != 0)
      Result += Buffer;
  }
};

Regelbasis 
Ermittle_Regeln (Clustering & Cluster,
		 double Z_Grenze,
		 Datensatz & Daten,
		 int Input_Dim,
		 BVektor & relevante_Dims,
		 Parameter_Typ PT,
		 BVektor & Diese_Cluster)
  return Result (0, 0, 0);
{
  int i;
  Regelbasis Buffer;

  for (i = 0; i < Diese_Cluster.Anzahl_gesetzt (); i++) {
    Buffer = Ermittle_Regeln (Cluster, Z_Grenze, Daten,
			      Input_Dim, relevante_Dims, PT,
			      Diese_Cluster.Lese_gesetzte (i));
    if (Buffer.Lese_Dimension () != 0)
      Result += Buffer;

  }
};

Regelbasis 
Ermittle_Regeln (Clustering & Cluster,
		 double Z_Grenze,
		 Datensatz & Daten,
		 int Input_Dim,
		 BVektor & relevante_Dims,
		 Parameter_Typ PT,
		 int ClusterNr)
  return Result (0, 0, 0);
{
  int i, InputDim = 0, OutputDim = 0, DatenNr, DimNr, OK = TRUE;
  DVektorArray DatenBuffer;
  Regel RegelBuffer;
  DMatrix *Zugehoerigkeit = &(Cluster.Lese_Zugehoerigkeit ());

  /* Zunaechst Input-Output_Dim feststellen */
  for (i = 0; i < Input_Dim; i++) {
    if (relevante_Dims[i])
      InputDim++;
  }
  for (i = Input_Dim; i < Daten.Lese_DatenDim (); i++) {
    if (relevante_Dims[i])
      OutputDim++;
  }

  RegelBuffer.Regel (InputDim, OutputDim, PT);

  /* DatenBuffer erstellen */
  DatenBuffer.DVektorArray (2, Daten.Lese_Groesse (), NULL);
  for (DatenNr = 0; DatenNr < Daten.Lese_Groesse (); DatenNr++) {
    DatenBuffer[DatenNr][1] = Zugehoerigkeit->Lese_i_j (ClusterNr, DatenNr);
  }

  i = 0;
  for (DimNr = 0; (DimNr < Daten.Lese_DatenDim ()) && OK; DimNr++) {
    /* einzelne Dimensionen durchlaufen */
    if (relevante_Dims[DimNr]) {
      for (DatenNr = 0; DatenNr < Daten.Lese_Groesse (); DatenNr++) {
	DatenBuffer[DatenNr][0] = Daten.Lese_Daten ()[DatenNr][DimNr];
      }
      if (!(RegelBuffer[i].Finde_Parameter (DatenBuffer, Z_Grenze)))
	OK = FALSE;		/* Fehler */
      RegelBuffer.Setze_Name (i, Daten.Lese_Name_Pointer (DimNr));
      i++;
    }
  }
  if (OK)
    Result += RegelBuffer;
};

Regelbasis 
Finde_Regeln (double Huegel_Grenze,
	      Findungs_Art Art, Clustering & Cluster,
	      double Z_Grenze,
	      Datensatz & Daten,
	      int Input_Dim,
	      BVektor & relevante_Dims,
	      Parameter_Typ PT)
  return Result (0, 0, 0);
{
  int i;
  Regelbasis Buffer;

  for (i = 0; i < Cluster.Lese_Zugehoerigkeit ().Lese_Dim_m (); i++) {
    Buffer = Finde_Regeln (Huegel_Grenze, Art, Cluster, Z_Grenze, Daten, Input_Dim,
			   relevante_Dims, PT, i);
    if (Buffer.Lese_Dimension () != 0)
      Result += Buffer;
  }
};

Regelbasis 
Finde_Regeln (double Huegel_Grenze,
	      Findungs_Art Art, Clustering & Cluster,
	      double Z_Grenze,
	      Datensatz & Daten,
	      int Input_Dim,
	      BVektor & relevante_Dims,
	      Parameter_Typ PT,
	      BVektor & Diese_Cluster)
  return Result (0, 0, 0);
{
  int i;
  Regelbasis Buffer;

  for (i = 0; i < Diese_Cluster.Anzahl_gesetzt (); i++) {
    Buffer = Finde_Regeln (Huegel_Grenze, Art, Cluster, Z_Grenze, Daten, Input_Dim,
		       relevante_Dims, PT, Diese_Cluster.Lese_gesetzte (i));
    if (Buffer.Lese_Dimension () != 0)
      Result += Buffer;
  }
};

Regelbasis 
Finde_Regeln (double Huegel_Grenze,
	      Findungs_Art Art, Clustering & Cluster,
	      double Z_Grenze,
	      Datensatz & Daten,
	      int Input_Dim,
	      BVektor & relevante_Dims,
	      Parameter_Typ PT,
	      int ClusterNr)
  return Result (0, 0, 0);
{
  int i, j, InputDim = 0, OutputDim = 0, DatenNr, HuegelAnzahl, HuegelNr,
    DimNr, OK = TRUE;
  DVektorArray DatenBuffer, Huegel_vorher;
  IVektor *Huegel = 0;
  DVektor Y;
  Regel RegelBuffer;
  DMatrix *Zugehoerigkeit = &(Cluster.Lese_Zugehoerigkeit ());

  /* Zunaechst Input-Output_Dim feststellen */
  for (i = 0; i < Input_Dim; i++) {
    if (relevante_Dims[i])
      InputDim++;
  }
  for (i = Input_Dim; i < Daten.Lese_DatenDim (); i++) {
    if (relevante_Dims[i])
      OutputDim++;
  }

  RegelBuffer.Regel (InputDim, OutputDim, PT);
/***************************/
  /* Huegel_vorher erstellen */
/***************************/
  Huegel_vorher.DVektorArray (InputDim, Daten.Lese_Groesse (), NULL);
  Y.DVektor (Daten.Lese_Groesse (), 0, NULL);
  j = 0;
  for (i = 0; i < InputDim; i++) {
    if (relevante_Dims[i]) {
      for (DatenNr = 0; DatenNr < Daten.Lese_Groesse (); DatenNr++)
	Huegel_vorher[DatenNr][j] = Daten.Lese_Daten ()[DatenNr][i];
      j++;
    }
  }
  for (DatenNr = 0; DatenNr < Daten.Lese_Groesse (); DatenNr++)
    Y[DatenNr] = Zugehoerigkeit->Lese_i_j (ClusterNr, DatenNr);

/************************/
  /* Huegel suchen lassen */
/************************/
// ********************************
  // am 07.09.95 durch den unteren Aufruf ersetzt. Hoffentlich ist der besser !!
  switch (Art) {
  case Dim_insgesamt:
    Huegel = Huegel_vorher.Finde_Huegel (Y, HuegelAnzahl, Huegel_Grenze,
					 NAEHER_ERLAUBT, WINKEL_COSINUS);
    break;
  case Dim_einzeln:
    Huegel = Huegel_vorher.Finde_Huegel (Y, HuegelAnzahl, Huegel_Grenze,
					 NAEHER_ERLAUBT);
    break;
  default:
    break;
  }
  /* DatenBuffer erstellen */
  if (HuegelAnzahl != 0) {
    DatenBuffer.DVektorArray (2, 0, NULL);

    for (HuegelNr = 0; HuegelNr < HuegelAnzahl; HuegelNr++) {	/* Alle Huegel durchforsten */
      DatenBuffer.Setze_Groesse (Huegel[HuegelNr].Lese_Dim ());
      for (DatenNr = 0; DatenNr < Huegel[HuegelNr].Lese_Dim (); DatenNr++) {
	DatenBuffer[DatenNr][1] =
	  (*Zugehoerigkeit)[ClusterNr][Huegel[HuegelNr][DatenNr]];
      }
      i = 0;
      for (DimNr = 0; (DimNr < Daten.Lese_DatenDim ()) && OK; DimNr++) {
	/* einzelne Dimensionen durchlaufen */
	if (relevante_Dims[DimNr]) {
	  for (DatenNr = 0; DatenNr < Huegel[HuegelNr].Lese_Dim (); DatenNr++) {
	    DatenBuffer[DatenNr][0] = Daten.Lese_Daten ()[Huegel[HuegelNr][DatenNr]][DimNr];
	  }
	  if (!(RegelBuffer[i].Finde_Parameter (DatenBuffer, Z_Grenze)))
	    OK = FALSE;
	  RegelBuffer.Setze_Name (i, Daten.Lese_Name_Pointer (DimNr));
	  i++;
	}
      }
      if (OK)
	Result += RegelBuffer;
    }
    for (i = 0; i < HuegelAnzahl; i++)
      Huegel[i]. ~ IVektor ();
    free (Huegel);
  }
};

double 
Berechne_RC (DVektorArray & GruppeAInput,
	     DVektorArray & GruppeBInput,
	     DVektorArray & OutputA,
	     DVektorArray & OutputB,
	     Regelbasis & RegelnA, Regelbasis & RegelnB)
{
  Norm DieNorm;
  double DiffA = 0, DiffB = 0;
  int i;
  Regelbasis_Ausgabe Dummy;

  for (i = 0; i < GruppeAInput.Lese_Groesse (); i++) {
    RegelnB.Berechne (GruppeAInput[i], Dummy);
    DiffA += DieNorm.d_quadr (Dummy.Lese_Ergebnisse (), OutputA[i]);
  }
  DiffA = DiffA / GruppeAInput.Lese_Groesse ();

  for (i = 0; i < GruppeBInput.Lese_Groesse (); i++) {
    RegelnA.Berechne (GruppeBInput[i], Dummy);
    DiffB += DieNorm.d_quadr (Dummy.Lese_Ergebnisse (), OutputB[i]);
  }
  DiffB = DiffB / GruppeBInput.Lese_Groesse ();

  return ((DiffA + DiffB) / 2);
};

/********************************************************/
/*              Alles zur Klasse Regel_Ausgabe           */
/********************************************************/
Regel_Ausgabe::Regel_Ausgabe (int InputDim, int OutputDim)
{
  int i;

  Input_Dim = InputDim;
  Output_Dim = OutputDim;

  InputHoehen.DVektor (InputDim, 0, NULL);
  if (InputDim != 0) {
    if ((X_OutputKurve = (DVektor *) malloc (sizeof (DVektor) * OutputDim)) == NULL)
      Fehlermeldung ("Regel_Ausgabe::Regel_Ausgabe", SPEICHERFEHLER);
    if ((Y_OutputKurve = (DVektor *) malloc (sizeof (DVektor) * OutputDim)) == NULL)
      Fehlermeldung ("Regel_Ausgabe::Regel_Ausgabe", SPEICHERFEHLER);
    for (i = 0; i < OutputDim; i++) {
      X_OutputKurve[i].DVektor ();
      Y_OutputKurve[i].DVektor ();
    }
  } else
    X_OutputKurve = Y_OutputKurve = NULL;

  Ergebnisse.DVektor (OutputDim, 0, NULL);
};

Regel_Ausgabe::~Regel_Ausgabe ()
{
  int i;

  if (Output_Dim != 0) {
    for (i = 0; i < Output_Dim; i++) {
      X_OutputKurve[i]. ~ DVektor ();
      Y_OutputKurve[i]. ~ DVektor ();
    }
    free (X_OutputKurve);
    free (Y_OutputKurve);
    X_OutputKurve = Y_OutputKurve = NULL;
  }
  Input_Dim = Output_Dim = 0;
};

void 
Regel_Ausgabe::Setze_Dim (int xDim, int yDim)
{
  int i;

  if (xDim != Input_Dim) {
    if (Output_Dim != 0) {
      for (i = 0; i < Output_Dim; i++) {
	X_OutputKurve[i]. ~ DVektor ();
	Y_OutputKurve[i]. ~ DVektor ();
      }
      free (X_OutputKurve);
      free (Y_OutputKurve);
      X_OutputKurve = Y_OutputKurve = NULL;
    }
    if (xDim != 0) {
      if ((X_OutputKurve = (DVektor *) malloc (sizeof (DVektor) * yDim)) == NULL)
	Fehlermeldung ("Regel_Ausgabe::Setze_Dim(int xDim, int yDim)", SPEICHERFEHLER);
      if ((Y_OutputKurve = (DVektor *) malloc (sizeof (DVektor) * yDim)) == NULL)
	Fehlermeldung ("Regel_Ausgabe::Setze_Dim(int xDim, int yDim)", SPEICHERFEHLER);
      for (i = 0; i < yDim; i++) {
	X_OutputKurve[i].DVektor ();
	Y_OutputKurve[i].DVektor ();
      }
    } else
      X_OutputKurve = Y_OutputKurve = NULL;
    Input_Dim = xDim;
    InputHoehen.Setze_Dim (xDim);
  }
  Output_Dim = yDim;
  Ergebnisse.Setze_Dim (yDim);
};

Regel_Ausgabe & Regel_Ausgabe::operator = (Regel_Ausgabe & Das) {
  int i;

  if (Das.Output_Dim != Output_Dim) {
    if (Output_Dim != 0) {
      for (i = 0; i < Output_Dim; i++) {
	X_OutputKurve[i]. ~ DVektor ();
	Y_OutputKurve[i]. ~ DVektor ();
      }
      free (X_OutputKurve);
      free (Y_OutputKurve);
      X_OutputKurve = Y_OutputKurve = NULL;
    }
    if (Das.Output_Dim != 0) {
      if ((X_OutputKurve = (DVektor *) malloc (sizeof (DVektor) * Das.Output_Dim)) == NULL)
	Fehlermeldung ("Regel_Ausgabe::operator=(Regel_Ausgabe& Das)", SPEICHERFEHLER);
      if ((Y_OutputKurve = (DVektor *) malloc (sizeof (DVektor) * Das.Output_Dim)) == NULL)
	Fehlermeldung ("Regel_Ausgabe::operator=(Regel_Ausgabe& Das)", SPEICHERFEHLER);
      for (i = 0; i < Das.Output_Dim; i++) {
	X_OutputKurve[i].DVektor ();
	Y_OutputKurve[i].DVektor ();
      }
    } else
      X_OutputKurve = Y_OutputKurve = NULL;
  }
  for (i = 0; i < Das.Input_Dim; i++) {
    X_OutputKurve[i] = Das.X_OutputKurve[i];
    Y_OutputKurve[i] = Das.Y_OutputKurve[i];
  }

  InputHoehen = Das.InputHoehen;
  Ergebnisse = Das.Ergebnisse;

  Input_Dim = Das.Input_Dim;
  Output_Dim = Das.Output_Dim;
};

/********************************************************/
/*         Alles zur Klasse RegelBasis_Ausgabe           */
/********************************************************/
Regelbasis_Ausgabe::Regelbasis_Ausgabe (int Groesse = 0, int InputDim = 0,
		    int OutputDim = 0)
{
  int i;

  Ergebnisse.DVektor (OutputDim, 0, NULL);
  if (Groesse != 0) {
    if ((Ausgaben = (Regel_Ausgabe **) malloc (sizeof (Regel_Ausgabe *) * Groesse)) == NULL)
      Fehlermeldung ("Regelbasis_Ausgabe::Regelbasis_Ausgabe", SPEICHERFEHLER);
  } else
    Ausgaben = NULL;
  for (i = 0; i < Groesse; i++)
    Ausgaben[i] = new Regel_Ausgabe (InputDim, OutputDim);
  Anzahl = Groesse;
};

Regelbasis_Ausgabe::~Regelbasis_Ausgabe ()
{
  int i;

  if (Anzahl != 0) {
    for (i = 0; i < Anzahl; i++)
      delete Ausgaben[i];
    free (Ausgaben);
    Ausgaben = NULL;
  }
  Anzahl = 0;
};

void 
Regelbasis_Ausgabe::Setze_Dim (int xDim, int yDim)
{
  int i;

  for (i = 0; i < Anzahl; i++) {
    Ausgaben[i]->Setze_Dim (xDim, yDim);
  }
  Ergebnisse.Setze_Dim (yDim);
};

void 
Regelbasis_Ausgabe::Setze_Groesse (int So)
{
  int i, xDim, yDim;
  Regel_Ausgabe **Buffer;

  if (Anzahl != 0) {
#if 0
    xDim = Ausgaben[0].Lese_InputDim ();
    yDim = Ausgaben[0].Lese_OutputDim ();
#else
    xDim = Ausgaben[0]->Lese_InputDim ();
    yDim = Ausgaben[0]->Lese_OutputDim ();
#endif
  } else
    xDim = yDim = 0;

  if (So != Anzahl) {
    if (So != 0) {
      Buffer = Ausgaben;
      if ((Ausgaben = (Regel_Ausgabe **) malloc (sizeof (Regel_Ausgabe *) * So)) == NULL)
	Fehlermeldung ("Regelbasis_Ausgabe::Regelbasis_Ausgabe", SPEICHERFEHLER);
      for (i = 0; (i < Anzahl) && (i < So); i++)
	Ausgaben[i] = Buffer[i];	/* alte uebernehmen */
      for (; i < Anzahl; i++)
	delete Buffer[i];	/* ueberfluessige */
      for (; i < So; i++)
	Ausgaben[i] = new Regel_Ausgabe (xDim, yDim);	/* brauche mehr */
      free (Buffer);
    } else {
      for (i = 0; i < Anzahl; i++)
	delete Ausgaben[i];
      free (Ausgaben);
      Ausgaben = NULL;
    }
    Anzahl = So;
  }
};

Regelbasis_Ausgabe & Regelbasis_Ausgabe::operator = (Regelbasis_Ausgabe & Das) {
  int i;

  if (Das.Anzahl != Anzahl) {
    for (i = 0; i < Anzahl; i++)
      delete Ausgaben[i];
    free (Ausgaben);
    Anzahl = Das.Anzahl;
    if (Anzahl != 0) {
      if ((Ausgaben = (Regel_Ausgabe **) malloc (sizeof (Regel_Ausgabe *) * Anzahl)) == NULL)
	Fehlermeldung ("Regelbasis_Ausgabe::operator=", SPEICHERFEHLER);
    } else
      Ausgaben = NULL;
    for (i = 0; i < Anzahl; i++)
      Ausgaben[i] = new Regel_Ausgabe (Das.Ausgaben[i]->Lese_InputDim (),
				       Das.Ausgaben[i]->Lese_OutputDim ());
  }
  for (i = 0; i < Anzahl; i++)
    *(Ausgaben[i]) = *(Das.Ausgaben[i]);
};

/***********************************************************/
Klasse::Klasse (int Dimension = 0, Parameter_Typ PT = Trapez)
{
  ((Dummy_Regel *) (this))->Dummy_Regel (Dimension, 0, PT);
};

Klasse::Klasse (const Klasse & Das)
{
  (*((Dummy_Regel *) this)) = ((const Dummy_Regel &) Das);
};

void 
Klasse::print ()
{
  int i;

  printf ("Falls ");
  for (i = 0; i < xDim; i++) {
    printf ("%s", Namen[i]);
    Daten[i]->print ();
    if (i + 1 != xDim)
      printf ("und   ");
  }
  printf ("dann Klasse %d.", Nummer);
};

void 
Klasse::Setze_Dimension (int So)
{
  int i;
  Parameter_Typ PT = Trapez;

  if (xDim != 0)
    PT = Daten[0]->Lese_Parameter_Typ ();

  if (So != xDim) {
    for (i = 0; i < xDim; i++) {
      free (Namen[i]);
      delete Daten[i];
    }
    free (Namen);
    free (Daten);
    Namen = NULL;
    Daten = NULL;
    if (So != 0) {
      if ((Namen = (char **) malloc (sizeof (char *) * So)) == NULL)
	  Fehlermeldung ("Klasse::Setze_Dimensionen", SPEICHERFEHLER);
      for (i = 0; i < So; i++) {
	if ((Namen[i] = (char *) malloc (sizeof (char) * NAMENLAENGE)) == NULL)
	    Fehlermeldung ("Klasse::Setze_Dimensionen", SPEICHERFEHLER);
      }
      if ((Daten = (Parameter **) malloc (sizeof (Parameter *) * So)) == NULL)
	Fehlermeldung ("Klasse::Setze_Dimensionen", SPEICHERFEHLER);
      switch (PT) {
      case Trapez:
	for (i = 0; i < So; i++)
	  Daten[i] = new Trapez_Parameter ();
	break;
      case Konvex:
	for (i = 0; i < So; i++)
	  Daten[i] = new Konvex_Parameter ();
	break;
      default:
	break;
      }
    } else
      Daten = NULL;
  }
  xDim = So;
};

void 
Klasse::Berechne (DVektor & Eingabe, Klassen_Ausgabe & Ausgabe)
{
  int i;

  Ausgabe.Setze_Dim (xDim);
  Ausgabe.Uebereinstimmung = 1;
  /* zunaechst die Hoehe berechnen */
  for (i = 0; i < xDim; i++) {
    Ausgabe.InputHoehen[i] = Daten[i]->Berechne_Hoehe (Eingabe[i]);
    if (Ausgabe.InputHoehen[i] < Ausgabe.Uebereinstimmung)
      Ausgabe.Uebereinstimmung = Ausgabe.InputHoehen[i];
  }
};

void 
Klasse::Berechne (DVektor & Eingabe, BVektor & Diese_Eingaben,
		  Klassen_Ausgabe & Ausgabe)
{
  int i;

  Ausgabe.Setze_Dim (xDim);
  if (Diese_Eingaben.Anzahl_gesetzt () == 0)
    Ausgabe.Uebereinstimmung = 0;
  else {
    Ausgabe.Uebereinstimmung = 1;
    /* zunaechst die Hoehe berechnen */
    for (i = 0; i < xDim; i++) {
      if (Diese_Eingaben[i]) {
	Ausgabe.InputHoehen[i] = Daten[i]->Berechne_Hoehe (Eingabe[i]);
	if (Ausgabe.InputHoehen[i] < Ausgabe.Uebereinstimmung)
	  Ausgabe.Uebereinstimmung = Ausgabe.InputHoehen[i];
      } else
	Ausgabe.InputHoehen[i] = 0;
    }
  }
};

Klasse & Klasse::operator = (Klasse & Das) {
  (*((Dummy_Regel *) this)) = ((Dummy_Regel &) Das);
};

Klasse 
Klasse_einlesen (FILE * File, int x)
  return Result (0, Trapez /* <- ist aber egal */ );
{
  int Buffer;

  fscanf (File, "%d", &Buffer);	/* Nummer einlesen */
  Result.File_einlesen (File, x, 0);
  Result.Setze_Nummer (Buffer);
};

/**************************************************************/
Klassifizierung::Klassifizierung (int Klassenanzahl = 0, int Dimension = 0)
{
  int i;

  Anzahl = Klassenanzahl;
  Dim = Dimension;

  if (Anzahl != 0) {
    if ((Klassen = (Klasse **) malloc (sizeof (Klasse *) * Anzahl)) == NULL)
      Fehlermeldung ("Klassifizierung::Klassifizierung", SPEICHERFEHLER);
    for (i = 0; i < Anzahl; i++)
      Klassen[i] = new Klasse (Dimension);
  } else
    Klassen = NULL;
};

Klassifizierung::~Klassifizierung ()
{
  int i;

  if (Anzahl != 0) {
    for (i = 0; i < Anzahl; i++)
      delete Klassen[i];
    free (Klassen);
    Dim = Anzahl = 0;
    Klassen = NULL;
  }
};

void 
Klassifizierung::print ()
{
  int i;

  for (i = 0; i < Anzahl; i++)
    Klassen[i]->print ();
};

void 
Klassifizierung::Setze_Dimension (int So)
{
  int j;

  Dim = So;
  for (j = 0; j < Anzahl; j++)
    Klassen[j]->Setze_Dimension (So);
};

void 
Klassifizierung::Setze_Klassenanzahl (int Damit)
{
  int i;
  Klasse **Buffer;
  if (Anzahl != Damit) {
    if (Damit != 0) {
      Buffer = Klassen;
      if ((Klassen = (Klasse **) malloc (sizeof (Klasse *) * Damit)) == NULL)
	Fehlermeldung ("Klassifizierung::Setze_Klassenanzahl()", SPEICHERFEHLER);
      for (i = 0; (i < Anzahl) && (i < Damit); i++)
	Klassen[i] = Buffer[i];	/* alte uebernehmen */
      for (; i < Anzahl; i++)
	delete Buffer[i];	/* ueberfluessige */
      for (; i < Damit; i++)
	Klassen[i] = new Klasse (Dim);	/* brauche mehr */
      free (Buffer);
    } else {
      for (i = 0; i < Anzahl; i++)
	delete Klassen[i];
      free (Klassen);
      Klassen = NULL;
    }
    Anzahl = Damit;
  }
};

void 
Klassifizierung::Speichern (char *Name)
{
  FILE *File;
  int i;

  if ((File = fopen (Name, "w")) == NULL) {
    Fehlermeldung ("Klassifizierung::Speichern(char *Name)", DATEIOEFFNENFEHLER);
  } else {
    fprintf (File, "classification\n");
    fprintf (File, "%d %d\n", Anzahl, Dim);

    for (i = 0; i < Anzahl; i++)
      Klassen[i]->Speichern (File);
    fclose (File);
  }
};

void 
Klassifizierung::Berechne (DVektor & Eingabe,
			   Klassifizierungs_Ausgabe & Ausgabe)
{
  BVektor Regeln (Anzahl, NULL), Eingaben (Eingabe.Lese_Dim (), NULL);

  Regeln = 1;
  Eingaben = 1;
  Berechne (Eingabe, Regeln, Eingaben, Ausgabe);
};

void 
Klassifizierung::Berechne (DVektor & Eingabe, BVektor & Diese_Regeln,
			   BVektor & Diese_Eingaben,
			   Klassifizierungs_Ausgabe & Ausgabe)
{
  int KlassenNr, KlassenBuffer = -1, i;
  double Max = 0;
  Ausgabe.geklappt = FALSE;
  Ausgabe.eindeutig = TRUE;

  Ausgabe.Setze_Dim (Dim);
  Ausgabe.Setze_Groesse (Anzahl);
  Ausgabe.Ergebnis = -1;	//0;

  Ausgabe.Aus_dieser_Regel = 0;
  Ausgabe.Klassen_Zugehoerigkeiten.Setze_Dim (Klassen_Nummern.Lese_Dim ());
  Ausgabe.Klassen_Zugehoerigkeiten = 0.0;

  if (Dim != 0) {
    for (KlassenNr = 0; KlassenNr < Anzahl; KlassenNr++) {
      /* Regeln auswerten */
      if (Diese_Regeln[KlassenNr]) {
#if 0
	Klassen[KlassenNr].Berechne (Eingabe, Diese_Eingaben, *(Ausgabe.Ausgaben[KlassenNr]));
#else
	Klassen[KlassenNr]->Berechne (Eingabe, Diese_Eingaben, *(Ausgabe.Ausgaben[KlassenNr]));
#endif
	/* die entsprechende Klassen_Zugehoerigkeit modifizieren */
#if 0
	i = Klassen_Nummern.Lese_Index (Klassen[KlassenNr].Lese_Nummer ());
#else
	i = Klassen_Nummern.Lese_Index (Klassen[KlassenNr]->Lese_Nummer ());
#endif
	if (Ausgabe.Ausgaben[KlassenNr]->Lese_Uebereinstimmung () > Ausgabe.Klassen_Zugehoerigkeiten[i])
	  Ausgabe.Klassen_Zugehoerigkeiten[i] = Ausgabe.Ausgaben[KlassenNr]->Lese_Uebereinstimmung ();
	/* jetzt die Ausgabe dieser Regeln speichern */
	if (Max < Ausgabe.Ausgaben[KlassenNr]->Lese_Uebereinstimmung ()) {
	  Max = Ausgabe.Ausgaben[KlassenNr]->Lese_Uebereinstimmung ();
	  Ausgabe.Ergebnis = Klassen[KlassenNr]->Lese_Nummer ();
	  Ausgabe.Aus_dieser_Regel = KlassenNr;
	  Ausgabe.geklappt = TRUE;
	  Ausgabe.eindeutig = TRUE;
	  KlassenBuffer = Ausgabe.Ergebnis;
	} else if ((Max == Ausgabe.Ausgaben[KlassenNr]->Lese_Uebereinstimmung ()) &&
	(Max != 0) && (Klassen[KlassenNr]->Lese_Nummer () != KlassenBuffer))
	  Ausgabe.eindeutig = FALSE;
      } else {
	Ausgabe.Ausgaben[KlassenNr]-> ~ Klassen_Ausgabe ();
      }
    }
  }
};

Klassifizierung & Klassifizierung::operator = (const Klassifizierung & Das) {
  int i;

  if (Das.Anzahl != Anzahl) {
#if 0
    this. ~ Klassifizierung ();
#else
    this-> ~ Klassifizierung ();
#endif
    Anzahl = Das.Anzahl;
    if (Anzahl != 0) {
      if ((Klassen = (Klasse **) malloc (sizeof (Klasse *) * Anzahl)) == NULL)
	Fehlermeldung ("Klassifizierung::operator=(Klassifizierung &Das)", SPEICHERFEHLER);
      for (i = 0; i < Anzahl; i++)
	Klassen[i] = new Klasse (*(Das.Klassen[i]));
    } else
      Klassen = NULL;
  } else {
    for (i = 0; i < Anzahl; i++)
      *(Klassen[i]) = *(Das.Klassen[i]);
  }
  Dim = Das.Dim;
  Klassen_Nummern = Das.Klassen_Nummern;
};

void 
Klassifizierung::operator+= (Klasse & Diese)
{
  Klasse **Buffer;
  int i, j;

  Buffer = Klassen;

  Dim = Diese.Lese_Dimension ();	/* nur zur Sicherheit */
  if ((Klassen = (Klasse **) malloc (sizeof (Klasse *) * (Anzahl + 1))) == NULL)
    Fehlermeldung ("Klassifizierung::operator+=(Klasse& Diese)", SPEICHERFEHLER);

  if (!(Klassen_Nummern.Ist_drinnen (Diese.Lese_Nummer ())))
    Klassen_Nummern.Plus_Sortiert (Diese.Lese_Nummer ());

  j = 0;
  for (i = 0; i < Anzahl; i++) {
    if (Diese.Lese_Nummer () > Buffer[j]->Lese_Nummer ())
      Klassen[i] = Buffer[j++];
    else {
      Klassen[i++] = new Klasse (Diese);
      for (; i < Anzahl; i++)
	Klassen[i] = Buffer[j++];
      break;
    }
  }
  Anzahl++;
  if (i < Anzahl)
    Klassen[i] = new Klasse (Diese);
  free (Buffer);
};

void 
Klassifizierung::operator+= (const Klassifizierung & Diese)
{
  Klasse **Buffer;
  int i, j, k = 0;

  Buffer = Klassen;

  Dim = Diese.Dim;		/* nur zur Sicherheit */

  if (Anzahl + Diese.Anzahl != 0) {
    if ((Klassen = (Klasse **) malloc (sizeof (Klasse *) * (Anzahl + Diese.Anzahl))) == NULL)
      Fehlermeldung ("Klassifizierung::operator+=(Klassifizierung& Diese)", SPEICHERFEHLER);

    for (i = 0; i < Diese.Lese_Klassenanzahl (); i++) {
      if (!(Klassen_Nummern.Ist_drinnen (Diese[i].Lese_Nummer ())))
	Klassen_Nummern.Plus_Sortiert (Diese[i].Lese_Nummer ());
    }

    j = 0;
    k = 0;
    for (i = 0; i < Anzahl + Diese.Anzahl; i++) {
      if (j < Anzahl) {
	if (k < Diese.Anzahl) {
	  if (Diese[k].Lese_Nummer () < Buffer[j]->Lese_Nummer ()) {
	    Klassen[i] = new Klasse (Diese[k++]);
	  } else {
	    Klassen[i] = Buffer[j++];
	  }
	} else {
	  Klassen[i] = Buffer[j++];
	}
      } else {
	Klassen[i] = new Klasse (Diese[k++]);
      }
    }
    Anzahl += Diese.Anzahl;

    free (Buffer);
  }
};

Klassifizierung 
Klassifizierung_einlesen (char *Name)
  return Result (0, 0);
{
  int i;
  FILE *File;
  char Buffer[20];

  if ((File = fopen (Name, "r")) == NULL) {
    Fehlermeldung ("Klassifizierung_einlesen(char *Name)", DATEIOEFFNENFEHLER);
    return (Result);
  }
  if (!(fscanf (File, "%18s", Buffer))) {
    Fehlermeldung ("Klassifizierung_einlesen(char *Name)", DATEIFORMATFEHLER);
    return (Result);
  }
  if (strcmp (Buffer, "classification")) {
    Fehlermeldung ("Klassifizierung_einlesen(char *Name)", DATEIFORMATFEHLER);
    return (Result);
  }
  if (2 != fscanf (File, "%d %d", &Result.Anzahl, &Result.Dim)) {
    Fehlermeldung ("Klassifizierung_einlesen(char *Name)", DATEIFORMATFEHLER);
    return (Result);
  }
  if ((Result.Klassen = (Klasse **) malloc (sizeof (Klasse *) * Result.Anzahl)) == NULL)
    Fehlermeldung ("Klassifizierung_einlesen(char *Name)", SPEICHERFEHLER);
  for (i = 0; i < Result.Anzahl; i++) {
    Result.Klassen[i] = new Klasse (Klasse_einlesen (File, Result.Dim));
    if (Lese_Fehlerstatus () != KEINFEHLER) {
      i++;
      for (; i < Result.Anzahl; i++)
	Result.Klassen[i] = NULL;
      Result. ~ Klassifizierung ();
      break;
    } else {
      /* Klassennummern feststellen */
      if (!(Result.Klassen_Nummern.Ist_drinnen (Result[i].Lese_Nummer ())))
	Result.Klassen_Nummern.Plus_Sortiert (Result[i].Lese_Nummer ());
    }
  }
};

Klassifizierung 
Ermittle_Klassifizierung (
			   Clustering & Cluster,
			   double Z_Grenze,
			   Datensatz & Daten,
			   int Input_Dim,
			   BVektor & relevante_Dims,
			   Parameter_Typ PT)
  return Result (0, 0);
{
  int i;

  for (i = 0; i < Cluster.Lese_Zugehoerigkeit ().Lese_Dim_m (); i++)
    Result += Ermittle_Klassifizierung (Cluster, Z_Grenze, Daten,
					Input_Dim, relevante_Dims, PT, i);
//  Result.Sortiere_nach_Klassen();
};

Klassifizierung 
Ermittle_Klassifizierung (
			   Clustering & Cluster,
			   double Z_Grenze,
			   Datensatz & Daten,
			   int Input_Dim,
			   BVektor & relevante_Dims,
			   Parameter_Typ PT,
			   BVektor & Diese_Cluster)
  return Result (0, 0);
{
  int i;

  for (i = 0; i < Diese_Cluster.Anzahl_gesetzt (); i++) {
    Result += Ermittle_Klassifizierung (Cluster, Z_Grenze, Daten,
					Input_Dim, relevante_Dims, PT,
					Diese_Cluster.Lese_gesetzte (i));
  }
//  Result.Sortiere_nach_Klassen();
};

Klassifizierung 
Ermittle_Klassifizierung (
			   Clustering & Cluster,
			   double Z_Grenze,
			   Datensatz & Daten,
			   int Input_Dim,
			   BVektor & relevante_Dims,
			   Parameter_Typ PT,
			   int ClusterNr)
  return Result (0, 0);
{
  int i = 0, j, DatenNr, DimNr, KlassenNr = 0;
  DVektorArray DatenBuffer;
  Klasse *KlassenBuffer;
  DMatrix *Zugehoerigkeiten = &(Cluster.Lese_Zugehoerigkeit ());
  double DBuffer = 0;


  KlassenBuffer = new Klasse (relevante_Dims.Anzahl_gesetzt (), PT);

  /* DatenBuffer erstellen */
  DatenBuffer.DVektorArray (2, Daten.Lese_Groesse (), NULL);
  for (DatenNr = 0; DatenNr < Daten.Lese_Groesse (); DatenNr++) {
    DatenBuffer[DatenNr][1] = Zugehoerigkeiten->Lese_i_j (ClusterNr, DatenNr);
  }

  i = 0;
  for (DimNr = 0; DimNr < Daten.Lese_DatenDim (); DimNr++) {
    /* einzelne Dimensionen durchlaufen */
    if (relevante_Dims[DimNr]) {
      for (DatenNr = 0; DatenNr < Daten.Lese_Groesse (); DatenNr++) {
	DatenBuffer[DatenNr][0] = Daten.Lese_Daten ()[DatenNr][DimNr];
      }
      (*KlassenBuffer)[i].Finde_Parameter (DatenBuffer, Z_Grenze);
#if 0
      KlassenBuffer.Setze_Name (i, Daten.Lese_Name_Pointer (DimNr));
#else
      KlassenBuffer->Setze_Name (i, Daten.Lese_Name_Pointer (DimNr));
#endif
      i++;
    }
  }
  /* Jetzt noch testen, welche Klasse */
  if (Daten.Lese_Daten_Typ () == Klassifiziert) {
    DBuffer = 0;
    for (j = 0; j < Zugehoerigkeiten->Lese_Dim_n (); j++) {
      if ((*Zugehoerigkeiten)[ClusterNr][j] > DBuffer) {
	DBuffer = (*Zugehoerigkeiten)[ClusterNr][j];
	KlassenNr = Daten.Lese_Daten ()[j].Lese_Nummer ();
      }
    }
  } else
    KlassenNr = Cluster.Lese_Cluster ()[ClusterNr].Lese_Nummer ();
  KlassenBuffer->Setze_Nummer (KlassenNr);
  Result += *KlassenBuffer;

  delete KlassenBuffer;
};

/*************************************************/
Klassen_Ausgabe::Klassen_Ausgabe (int Dimension = 0)
{
  InputHoehen.DVektor (Dimension, 0, NULL);
};

Klassen_Ausgabe & Klassen_Ausgabe::operator = (Klassen_Ausgabe & Das) {
  InputHoehen = Das.InputHoehen;
  Uebereinstimmung = Das.Uebereinstimmung;
};

Klassifizierungs_Ausgabe::Klassifizierungs_Ausgabe (int Groesse = 0, int Dim = 0)
{
  int i;

  Ergebnis = 0;
  if (Groesse != 0) {
    if ((Ausgaben = (Klassen_Ausgabe **) malloc (sizeof (Klassen_Ausgabe *) * Groesse)) == NULL)
      Fehlermeldung ("Klassifizierungs_Ausgabe::Klassifizierungs_Ausgabe(...)", SPEICHERFEHLER);
  } else
    Ausgaben = NULL;
  for (i = 0; i < Groesse; i++)
    Ausgaben[i] = new Klassen_Ausgabe (Dim);

  Anzahl = Groesse;
};

Klassifizierungs_Ausgabe::~Klassifizierungs_Ausgabe ()
{
  int i;

  if (Anzahl != 0) {
    for (i = 0; i < Anzahl; i++)
      delete Ausgaben[i];
    free (Ausgaben);
    Ausgaben = NULL;
  }
  Anzahl = 0;
  Klassen_Zugehoerigkeiten. ~ DVektor ();
};

void 
Klassifizierungs_Ausgabe::Setze_Dim (int Dim)
{
  int i;

  for (i = 0; i < Anzahl; i++) {
    Ausgaben[i]->Setze_Dim (Dim);
  }
};

void 
Klassifizierungs_Ausgabe::Setze_Groesse (int So)
{
  int i, Dim;
  Klassen_Ausgabe **Buffer;

  if (Anzahl != 0)
#if 0
    Dim = Ausgaben[0].Lese_Dim ();
#else
    Dim = Ausgaben[0]->Lese_Dim ();
#endif
  else
    Dim = 0;

  if (So != Anzahl) {
    if (So != 0) {
      Buffer = Ausgaben;
      if ((Ausgaben = (Klassen_Ausgabe **) malloc (sizeof (Klassen_Ausgabe *) * So)) == NULL)
	Fehlermeldung ("void Klassifizierungs_Ausgabe::Setze_Groesse(int So)", SPEICHERFEHLER);
      for (i = 0; (i < Anzahl) && (i < So); i++)
	Ausgaben[i] = Buffer[i];	/* alte uebernehmen */
      for (; i < Anzahl; i++)
	delete Buffer[i];	/* ueberfluessige */
      for (; i < So; i++)
	Ausgaben[i] = new Klassen_Ausgabe (Dim);	/* brauche mehr */
      free (Buffer);
    } else {
      for (i = 0; i < Anzahl; i++)
	delete Ausgaben[i];
      free (Ausgaben);
      Ausgaben = NULL;
    }
    Anzahl = So;
  }
};

Klassifizierungs_Ausgabe & Klassifizierungs_Ausgabe::operator = (Klassifizierungs_Ausgabe & Das) {
  int i;

  if (Das.Anzahl != Anzahl) {
    for (i = 0; i < Anzahl; i++)
      delete Ausgaben[i];
    free (Ausgaben);
    Anzahl = Das.Anzahl;
    if (Anzahl != 0) {
      if ((Ausgaben = (Klassen_Ausgabe **) malloc (sizeof (Klassen_Ausgabe *) * Anzahl)) == NULL)
	Fehlermeldung ("Klassifizierungs_Ausgabe::operator=", SPEICHERFEHLER);
    } else
      Ausgaben = NULL;
    for (i = 0; i < Anzahl; i++)
      Ausgaben[i] = new Klassen_Ausgabe (Das.Ausgaben[i]->Lese_Dim ());
  }
  for (i = 0; i < Anzahl; i++)
    *(Ausgaben[i]) = *(Das.Ausgaben[i]);
  Ergebnis = Das.Ergebnis;
  Aus_dieser_Regel = Das.Aus_dieser_Regel;
  geklappt = Das.geklappt;
  eindeutig = Das.eindeutig;
  Klassen_Zugehoerigkeiten = Das.Klassen_Zugehoerigkeiten;
};
