//**************************************************************
//*   filename: saveloadwindow.h                               *
//*                                                            *
//**************************************************************
//* programmed by: Thomas Wagner                               *
//* last change:  (XXX: not updated)                           *
//**************************************************************
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>

class SaveLoadWindow;

#ifndef SAVELOADWINDOW_H
#define SAVELOADWINDOW_H

#include "window.h"
#include "mainwindow.h"
#include "textbox.h"
#include "actionicon.h"
#include "selectwindow.h"
#include "dialog.h"

// define for SaveLoadWindow
enum SAVELOAD_ACTION {
  SAVELOAD_SELECTED_OK,
  SAVELOAD_SELECTED_CANCEL,
  SAVELOAD_CHANGESELECTED_ACTION,
  SAVELOAD_TEXTDOUBLECLICKED,
  SAVELOAD_DIALOG_CONFIRMED
};

#define LOADSAVEOUTSIDEBORDER 10
#define LOADSAVEINSIDEBORDER   8

// define for SaveLoadWindow.status
#define WORK_AS_LOAD_SELECTOR  1
#define WORK_AS_SAVE_SELECTOR  2

class SaveLoadWindow:
  public BigWindow
{
  Pixmap pixmap;
  BigWindow *Parent;
  MainWindow *Main;
  SelectWindow *fileselectwindow;
  ActionIcon *OK, *Cancel;
  int okactionnumber;
  char *path;
  unsigned short status;
  TextBox *selectedfile;
    public:
    SaveLoadWindow (Display * initdisplay,
		    GC initgc,
		    MainWindow * initMain,
		    XFontStruct * fontstruct,
		    int initx, int inity,
		    int initokactionnumber,
		    char *text,
		    unsigned short initstatus);
    virtual ~ SaveLoadWindow ();
  virtual void HandleEvent (XEvent * Event);
  virtual void Action (int Actionnumner, int value);
  virtual void MapMe ();
  void ChangeFunction (unsigned short newstatus,
		       BigWindow * newParent,
		       int newokactionnumber,
		       char *newtext);

    protected:
  void Relaoddirectory ();
  char Fileexists (char *filename);
  void Onepathup ();
  SelectWindowInfo *Loaddirectory (short *filenumber);
  char *Getfullfilename ();
};

#endif
