//**************************************************************
//*   filename: selecticon.h                                   *
//*                                                            *
//**************************************************************
//* programmed by: Thomas Wagner                               *
//* last change:  (XXX: not updated)                           *
//**************************************************************
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>

class SelectIconlist;
class SelectIcon;

#ifndef SELECTICON_H
#define SELECTICON_H

#include "icon.h"

#define SELECTICONLIST_ISMAPPED (1<<0)

class SelectIcon:
  public Icon
{
  friend class SelectIconlist;
    protected:
  int actionnumber;
  BigWindow *ParentWindow;
  SelectIconlist *list;
    public:
    SelectIcon (Display * initdisplay,
		GC initgc,
		BigWindow * initParentWindow,
		XFontStruct * fontstruct,
		int initx, int inity, int initwidth, int initheight,
		char *inittext,
		char *bmptext,
		short bmpwidth, short bmpheight,
		int initactionnumber,
		unsigned short initstatus);
  void Selectme ();
  virtual void HandleEvent (XEvent * Event);
};

class SelectIconlist
{
  protected:
  SelectIconlist * Next;
  SelectIcon *selecticon;
  char status;

    public:
    SelectIconlist ();
  // delete full list with all icons
   ~SelectIconlist ();
  void operator += (SelectIcon * newselecticon);
  void MakeallSelectable ();
  void MakeallUnselectable ();
  void MakeIconSelectable (int theactionnumber);
  void MakeIconUnselectable (int theactionnumber);
  void SelectanIcon (int theactionnumber);
  void UnselectanIcon (int theactionnumber);
  void MoveSelectIcons (int xdiff, int ydiff);
  void MapMe ();
  void UnmapMe ();
  char IsMapped () {
    if (status & SELECTICONLIST_ISMAPPED)
      return TRUE;
    else
      return FALSE;
  } int GetSelectedvalue ();
  void SelectChange (SelectIcon * selectme);
    protected:
    SelectIcon * GetSelectIcon (int theactionnumber);
};

#endif
