//**************************************************************
//*   filename: textbox.h                                      *
//*                                                            *
//**************************************************************
//* programmed by: Thomas Wagner                               *
//* last change:  (XXX: not updated)                           *
//**************************************************************
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

class TextBox;

#ifndef TEXTBOX_H
#define TEXTBOX_H

#include "window.h"

#define DOUBLELENGTH 12

/* defines for TextBox */
#define DOUBLECLICKTIME              300
#define DEFAULT_TEXTBOXBDWIDTH      1

#define TEXTOPTION_DEFAULT          0
#define TEXTOPTION_SELECTABLE       (1<<0)
#define TEXTOPTION_DARK             (1<<1)
#define TEXTOPTION_SELECTED         (1<<2)
#define TEXTOPTION_GIVENXPOS        (1<<3)
#define TEXTOPTION_DOUBLECLICK      (1<<4)
#define TEXTOPTION_TEXTISPATH       (1<<5)	// used by saveloadwindow
#define TEXTOPTION_TEXTINPUT        (1<<6)
#define TEXTOPTION_DOUBLEINPUT      (1<<7)
#define TEXTOPTION_INTINPUT         (1<<8)

class TextBox:
  public Window_Info
{
  unsigned short textx, texty;
  unsigned short status;
  short givenxpos;
  int actionnumber;
  int clickactionnumber;
  unsigned short textpos;		// used, when input possible

  BigWindow *Parent;
    public:
    TextBox (Display * initdisplay,
	     GC initgc,
	     BigWindow * initParent,
	     XFontStruct * fontstruct,
	     int initx, int inity,
	     int initwidth, int initheight,
	     int Givenxpos,
	     char *inittext,
	     int borderwidth,
	     unsigned short initstatus,
	     int initactionnumber,
	     int Clickactionnumber);
    virtual ~ TextBox ();
  virtual void HandleEvent (XEvent * Event);
  int IsSelected ();
  void SelectMe ();
  void UnselectMe ();
  void MakeMeSelectable ();
  void MakeMeUnselectable ();
  void ChangeText (char *newtext);
  void ChangeText (int shortvalue);
  void ChangeText (double doublevalue);
  unsigned short GetStatus () {
    return status;
  } void SetStatus (unsigned short newstatus);
    protected:
  void Redraw ();
};

#endif
